## Makefile for building Lopster2 Windows version using Mingw
## Use: make -f makefile.win32



# Please update according to your system
#TOP = ../..
LOPSTER = ../..
SUBDIRS = $(LOPSTER)/lcore $(LOPSTER)/lcore/gtk2_ui $(LOPSTER)/plugin/napster $(LOPSTER)/plugin/napster/gtk2_ui 

# This value should be changed according to the path(s) where to find your INCLUDES AND LIB FILES
BASE_INCLUDE_LIB = $(TOP)/../INCLUDELIBS

UIC = uic.exe
MOC = moc.exe
RCC = rcc.exe
CC = mingw32-gcc.exe -mms-bitfields
MAKE = mingw32-make.exe
CP = cp.exe
RM = rm.exe
MAKELALIAS = $(TOP)/makelalias.pl

# install (for testing) directories
INSTALL_BASE = result.mingw
INSTALL_BASE_PLUGINS = result.mingw\plugins

INCLUDES = -I$(BASE_INCLUDE_LIB)/include 
INCLUDES += -I$(BASE_INCLUDE_LIB)/include/glib-2.0 
INCLUDES += -I$(BASE_INCLUDE_LIB)/lib/glib-2.0/include

GTK2_INCLUDES = -I$(BASE_INCLUDE_LIB)\include\gtk-2.0 
GTK2_INCLUDES += -I$(BASE_INCLUDE_LIB)\lib\gtk-2.0\include 
GTK2_INCLUDES += -I$(BASE_INCLUDE_LIB)\include\pango-1.0 
GTK2_INCLUDES += -I$(BASE_INCLUDE_LIB)\include\atk-1.0 
GTK2_INCLUDES += -I$(BASE_INCLUDE_LIB)\include\cairo 

QT4_INCLUDES   = -I"C:/Qt/4.3.0/include/QtCore" 
QT4_INCLUDES  += -I"C:/Qt/4.3.0/include/QtGui" 
QT4_INCLUDES  += -I"C:/Qt/4.3.0/include" 
QT4_INCLUDES  += -I"C:/Qt/4.3.0/include/ActiveQt" 
QT4_INCLUDES  += -I"C:/Qt/4.3.0/mkspecs/win32-g++"


DEFS = -DHAVE_CONFIG_H -DWIN32 -D_WIN32 -D__MINGW__ 
#DEFS += -DLOPSTER_LOCALE_DIR=\"./plugins\" -DPACKAGE_DATA_DIR=\"./plugins\" 
#DEFS += -DPACKAGE_LIB_DIR=\"./plugins\" 
 
LIBS = -L$(BASE_INCLUDE_LIB)/lib  
# -lzlib    LIBS += -L$(BASE_INCLUDE_LIB)/libxml_MINGW  
LIBS += -luser32 -lwsock32 -lws2_32 -lgdi32 
LIBS += -logg -lintl -lglib-2.0 -lgmodule-2.0 
LIBS += -llibxml2 -lgthread-2.0 -liconv -lzdll -lbz2
# LIBS += -lcrypto


GTK2_LIBS = -lgtk-win32-2.0 -lgdk-win32-2.0 -lgdk_pixbuf-2.0 -lpango-1.0 
GTK2_LIBS += -lpangoft2-1.0 -latk-1.0 -lgmodule-2.0 -lgobject-2.0 -lcairo

QT4_LIBS = -L"c:/Qt/4.3.0/lib" -lmingw32 -lqtmain -lQtGui4 -lQtCore4

################
# The including makefile should define INCLUDES, DEFINES and
# DEPCFLAGS.  INCLUDES are the includes related to the module being
# built.  DEFINES similarly. DEPCFLAGS should be set to a set of
# GLIB_CFLAGS, GTK_CFLAGS etc corresponding to what other modules we
# depend on.

CFLAGS = $(DEFS) $(INCLUDES) $(DEFINES) $(DEPCFLAGS) $(WARNINGS)
CXXFLAGS = $(DEFS) $(INCLUDES) $(DEFINES) $(DEPCFLAGS) $(WARNINGS)
################
# Useful rules


.SUFFIXES: .cpp .cc .cxx .c .ui .h .moc.cpp .moc.h .qrc .rcc

.cpp.o:
	$(CXX) -c $(CXXFLAGS) -o $@ $<

.cc.o:
	$(CXX) -c $(CXXFLAGS) -o $@ $<

.cxx.o:
	$(CXX) -c $(CXXFLAGS) -o $@ $<

.c.o:
	$(CC) -c $(CFLAGS) -o $@ $<

.ui.h:
	$(UIC) -o $@ $<

.h.moc.cpp:
	$(MOC) -o $@ $< 

.h.moc.h:
	$(MOC) -o $@ $< 

.qrc.rcc:
	$(RCC) -binary $< -o $@ 

####### Build rules
#	mkdir -p -- ui 
#	rm -f $@ $@.tmp 
#	echo "#define Q_(a,b) QString::fromUtf8(_(a))" > $@.tmp 
#	$(UIC) -tr "Q_" $< >> $@.tmp 
#	sed -i -e 's/Q_(\"_(\\\"\(.*\)\\\")"/Q_("\1"/' $@.tmp 
#	mv -f $@.tmp $@ 

# The default target should be "all"

default: all

#clean::
#	-rm *.o *.i *.exe *.dll *.a *.base *.exp *.def
#cleandll::
#	-rm *.exe *.dll *.a *.exp *.def
