/* Copyright (C) 2005 sgop@users.sourceforge.net
 * This is free software distributed under the terms of the
 * GNU Public License.  See the file COPYING for details.
 */
/* $Revision: 1.3 $
 * $Date: 2006/07/22 17:11:45 $
 * $Author: sid4u $
 */

#ifndef _BROWSE_H_
#define _BROWSE_H_

typedef struct _browse_t browse_t;

#include "file_tree.h"
#include "search.h"
#include "user.h"
#include "module.h"

G_BEGIN_DECLS

#define BROWSE(arg) ((browse_t*)(arg))

/*
typedef struct {
  void (*browse_init)(browse_t* browse, const char* name);
  browse_t* (*browse_new)(const char* name);
  void (*browse_destroy)(browse_t* browse);
  void (*browse_insert_file)(browse_t* browse, file_t* file);
  void (*browse_set_status)(browse_t* browse, const char* status);
  void (*browse_set_progress)(browse_t* browse, double prog,
			      const char* status);
} BrowseIF;
*/

struct _browse_t {
  file_tree_t _tree;
  user_t* user;
};

typedef struct {
  file_node_t _node;
} browse_node_t;

module_t* browse_module_instance();

void browse_init(browse_t* browse, user_t* user);
void browse_destroy(browse_t* browse);
browse_t* browse_find(user_t* user);

void browse_insert_file(browse_t* browse, file_t* file);

void browse_set_status(browse_t* browse, const char* status);
void browse_set_progress(browse_t* browse, double prog, const char* status);

G_END_DECLS

#endif
