/* Copyright (C) 2005 sgop@users.sourceforge.net
 * This is free software distributed under the terms of the
 * GNU Public License.  See the file COPYING for details.
 */
/* $Revision: 1.6 $
 * $Date: 2006/07/22 17:11:46 $
 * $Author: sid4u $
 */

#ifndef _FILES_H_
#define _FILES_H_

#include "attribute.h"

G_BEGIN_DECLS

/** @defgroup FileModule File handling 
 * @ingroup BasicFramework
 */
/*@{*/

#define FILE(arg) ((file_t*)(arg))

/** The file class.*/
typedef struct {
  attr_container_t _ac;  ///< the base class
  char* localname;       ///< The local filename
  char* netname;         ///< The original filename, no UTF-8!!
  char* filename;        ///< the filename without foldername
  int media;             ///< the mediatype of the file.
  char* mimetype;        ///< the mimetpe of the file.
  file_size_t size;      ///< the sizen of the file.
} file_t;

file_t* file_new(void);
void    file_init(file_t* file);
void    file_copy (file_t* dest, file_t* source, const char* domain);
file_t* file_clone(file_t* source, const char* attr);
void    file_destroy(file_t* file);

char* win2local(char *name);
char* local2win(char *name);
char* unix2win(char* name);

/* void file_set_unixname (file_t* file, const char* name); */
void file_set_origname(file_t* file, char* name);
void file_set_locname(file_t* file, char* name);

/*@}*/

G_END_DECLS
#endif
