/* Copyright (C) 2005 sgop@users.sourceforge.net
   This is free software distributed under the terms of the
   GNU Public License.  See the file COPYING for details. */

#ifndef __GTK_CELL_RENDERER_DOWNLOAD_H__
#define __GTK_CELL_RENDERER_DOWNLOAD_H__

#include <gtk/gtkcellrenderer.h>

#include "lcore/download.h"

G_BEGIN_DECLS

#define GTK_TYPE_CELL_RENDERER_DOWNLOAD           (gtk_cell_renderer_get_type ())
#define GTK_CELL_RENDERER_DOWNLOAD(obj)		  (G_TYPE_CHECK_INSTANCE_CAST ((obj), GTK_TYPE_CELL_RENDERER_DOWNLOAD, GtkCellRendererDownload))
#define GTK_CELL_RENDERER_DOWNLOAD_CLASS(klass)	  (G_TYPE_CHECK_CLASS_CAST ((klass), GTK_TYPE_CELL_RENDERER_DOWNLOAD, GtkCellRendererDownloadClass))
#define GTK_IS_CELL_RENDERER_DOWNLOAD(obj)		  (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GTK_TYPE_CELL_RENDERER_DOWNLOAD))
#define GTK_IS_CELL_RENDERER_DOWNLOAD_CLASS(obj)  (G_TYPE_CHECK_CLASS_TYPE ((obj), GTK_TYPE_CELL_RENDERER_DOWNLOAD))
#define GTK_CELL_RENDERER_DOWNLOAD_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GTK_TYPE_CELL_RENDERER_DOWNLOAD, GtkCellRendererDownloadClass))

typedef struct _GtkCellRendererDownload      GtkCellRendererDownload;
typedef struct _GtkCellRendererDownloadClass GtkCellRendererDownloadClass;
typedef struct _GtkCellRendererDownloadPriv  GtkCellRendererDownloadPriv;

typedef struct {
  download_t* download;
  source_t* source;
} rend_dl_data_t;

struct _GtkCellRendererDownload {
  GtkCellRenderer parent_instance;
  GtkCellRendererDownloadPriv* priv;
};

struct _GtkCellRendererDownloadClass{
  GtkCellRendererClass parent_class;
};

GType gtk_cell_renderer_download_get_type (void) G_GNUC_CONST;
GtkCellRenderer* gtk_cell_renderer_download_new(void);

G_END_DECLS

#endif
