/* Copyright (C) 2005-2006 sgop@users.sourceforge.net
 * This is free software distributed under the terms of the
 * GNU Public License.  See the file COPYING for details.
 */
/* $Revision: 1.7 $
 * $Date: 2006/10/29 00:52:56 $
 * $Author: sgop $
 */

#ifndef _UI_CHAT_H_
#define _UI_CHAT_H_

#include <gtk/gtk.h>
#include "lcore/chat.h"

typedef void (*PrintFunc)(GtkTextBuffer*, GtkTextIter*, va_list);

typedef struct {
  GtkTextView** view;		// text views
  GtkTextBuffer** buffer;	// text buffers
  int no_buffers;
  GtkLabel* title;
  GtkLabel* label;
  GtkWidget* tbutton;		// label close button
  GtkWidget* toplevel;		// toplevel widget
  GtkWidget* real_toplevel;	// toplevel widget
  GtkWidget* window;		// window, if present
} chat_gui_t;

void ui_chat_init(void);

GtkWidget* ui_create_chat_content(void);
void ui_chat_register_print_func(const char* name, PrintFunc func);

void ui_chat_page_add(chat_page_t* page, GtkWidget* controls, GtkWidget* add, ...);
void ui_chat_page_remove(chat_page_t* page);
void ui_chat_create_simple_page(chat_page_t* page);

GtkTextBuffer* ui_chat_new_buffer(void);
GtkWidget* ui_chat_new_text_view(GtkTextBuffer* buffer);

void ui_server_message(const char* proto, char* message);

void ui_chat_register_tag(GtkTextTag* tag);
GtkTextTag*
ui_chat_register_tag_from_style(const char* name, const char* style);

void ui_chat_switch_page(chat_page_t* page);
gboolean ui_chat_page_printable(chat_page_t* page);
void ui_chat_create_simple_page(chat_page_t* page);
void ui_chat_print(chat_page_t* page, int index, va_list ap);
void ui_chat_page_update_title(chat_page_t* page, const char* title);

#endif
