/* Copyright (C) 2005 sgop@users.sourceforge.net
   This is free software distributed under the terms of the
   GNU Public License.  See the file COPYING for details. */

#ifndef _UI_DIALOG_H_
#define _UI_DIALOG_H_

#include <gtk/gtk.h>

typedef struct _ui_page_t ui_page_t;
typedef struct _ui_dialog_t ui_dialog_t;

typedef GtkWidget* (*PageCreateFunc)(ui_page_t*);
typedef const char* (*PageChangeFunc)(ui_page_t*, gboolean next);

ui_dialog_t* ui_dialog_new(const char* title, gboolean allow_cancel);
void ui_dialog_add_page(ui_dialog_t* dialog, ui_page_t* page);
void ui_dialog_set_modal(ui_dialog_t* dialog, gboolean set);
void ui_dialog_set_progress(ui_dialog_t* dialog, double progress);
void ui_dialog_start(ui_dialog_t* dialog);

ui_page_t* ui_page_new(const char* title, PageCreateFunc create,
                       PageChangeFunc enter, PageChangeFunc leave);
ui_dialog_t* ui_page_get_dialog(ui_page_t* page);
void ui_page_set_data();
void* ui_page_get_data(ui_page_t* page);

#endif
