/* Copyright (C) 2005-2006 sgop@users.sourceforge.net
 * This is free software distributed under the terms of the
 * GNU Public License.  See the file COPYING for details.
 */
/* $Revision: 1.8 $
 * $Date: 2007/04/29 09:21:47 $
 * $Author: sgop $
 */

#ifndef _UI_FILETREE_H_
#define _UI_FILETREE_H_

#include "lcore/file_tree.h"

typedef struct {
    GtkWidget* main_link;
    GtkWidget* paned;
    GtkWidget* bottom_box;
    
    GtkTreeStore* folder_tree;  //
    GtkListStore* file_list;    //
    GtkTreeView* folder_view;
    GtkTreeView* file_view;
    
    GtkLabel* sum_label1;
    GtkLabel* sum_label2;
    GtkWidget* search_entry;
    
    GtkWidget* status_label;
    GtkWidget* progress;
    GtkWidget* abort_button;
    GFunc abort_func;
    void* abort_data;
    gulong abort_signal;

    GtkTreeViewColumn* col_file[3];
    file_node_t* current_node;
    file_tree_t* tree;
    gulong signal;
    
    int hide_timeout;
    char* search_token;
    int search_timeout;
} tree_gui_t;

GtkWidget* ui_filetree_create_page(tree_gui_t* data, GtkBox* header, GtkBox* hline);
void ui_filetree_scroll_to_parent(file_tree_t* tree, file_node_t* node);
void ui_filetree_assign_new_tree(tree_gui_t* data, file_tree_t* tree);

void ui_file_tree_update_label(file_tree_t* tree, const char* label);
void ui_file_tree_set_progress(file_tree_t* tree, double progress);
void ui_file_tree_set_progress_name(file_tree_t* tree, const char* name);
void ui_file_tree_set_abort(file_tree_t* tree, GFunc func, void* user_data);

#endif
