/* Copyright (C) 2005 sgop@users.sourceforge.net This is free software
 * distributed under the terms of the GNU Public License.  See the
 * file COPYING for details.
 */
/* $Revision: 1.3 $
 * $Date: 2006/07/22 17:11:58 $
 * $Author: sid4u $
 */

#include <gtk/gtk.h>
#include "lcore/l_i18n.h"

static GtkNotebook* Notebook = NULL;

static void ui_add_hotlist_subpage(const char* name, GtkWidget* widget) {
  GtkWidget* label;

  label = gtk_label_new(name);
  gtk_widget_show(label);
  gtk_notebook_append_page(Notebook, widget, label);
}

GtkWidget* ui_create_hotlist_content() {
  GtkWidget* notebook;
  GtkWidget* swindow;
  GtkWidget* vbox;
  GtkWidget* hpaned;
  
  notebook = gtk_notebook_new ();
  gtk_widget_show (notebook);
  Notebook = GTK_NOTEBOOK(notebook);
  gtk_notebook_set_scrollable (Notebook, TRUE);
  gtk_notebook_set_tab_pos (Notebook, GTK_POS_LEFT);

  //////////////
  hpaned = gtk_hpaned_new();
  gtk_widget_show(hpaned);
  
  vbox = gtk_vbox_new(FALSE, 0);
  gtk_widget_show(vbox);
  
  swindow = gtk_scrolled_window_new(NULL, NULL);
  gtk_widget_show(swindow);
  gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW(swindow),
				 GTK_POLICY_NEVER, GTK_POLICY_AUTOMATIC);
  /*
  gtk_scrolled_window_set_shadow_type(GTK_SCROLLED_WINDOW (swindow),
				      GTK_SHADOW_IN);
  */
  gtk_scrolled_window_add_with_viewport(GTK_SCROLLED_WINDOW (swindow),
					vbox);
  gtk_paned_pack1(GTK_PANED(hpaned), swindow, TRUE, TRUE);

  swindow = gtk_scrolled_window_new(NULL, NULL);
  gtk_widget_show(swindow);
  gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW(swindow), 
                                 GTK_POLICY_AUTOMATIC,
                                 GTK_POLICY_AUTOMATIC);
  gtk_scrolled_window_set_shadow_type(GTK_SCROLLED_WINDOW(swindow),
                                      GTK_SHADOW_IN);
  gtk_paned_pack2(GTK_PANED(hpaned), swindow, TRUE, TRUE);

  
  ui_add_hotlist_subpage(_("Buddies"), hpaned);
  return notebook;
}
