#ifndef _UI_NOTEBOOK_H_
#define _UI_NOTEBOOK_H_

#include <gtk/gtk.h>

typedef void (*TabChangedFunc)(void* data);

typedef struct {
  GtkNotebook* notebook;
  GtkBox* tab_box;
  GList* pages;
  GList* current;
  GSList* group;
  TabChangedFunc change;
  GtkOrientation orient;
} ui_nb_t;

ui_nb_t* ui_create_notebook(TabChangedFunc change, GtkOrientation orientation,
                            gboolean extended);
void ui_notebook_add_page(ui_nb_t* nb, GtkWidget* page, GtkWidget* label, void* data);
void ui_notebook_remove_page(ui_nb_t* nb, void* data);
void ui_notebook_switch_to_data (ui_nb_t* nb, void* data);
void ui_notebook_switch_to_child(ui_nb_t* nb, GtkWidget* child);
void ui_notebook_switch_to_index(ui_nb_t* nb, unsigned index);


#endif
