/* Copyright (C) 2005-2008 sgop@users.sourceforge.net
 * This is free software distributed under the terms of the
 * GNU Public License.  See the file COPYING for details.
 */
/* $Revision: 1.10 $
 * $Date: 2009/02/01 13:53:12 $
 * $Author: sgop $
 */

#include <gtk/gtk.h>

#include "ui_tooltips.h"
#ifdef WIN32
#include "lgtk2corealias.h"
#endif

static gboolean query_tv_tooltip(
        GtkTreeView* tv, gint x, gint y, gboolean keyboard_mode,
        GtkTooltip* tooltip, FancyTipsFunc func)
{
    //FIXME
    if (!keyboard_mode)
    {
        void* object = NULL;
        GtkTreePath* path = NULL;
        unsigned depth = 0;
        gint bx, by;

        gtk_tree_view_convert_widget_to_bin_window_coords(tv, x, y, &bx, &by);
        if (gtk_tree_view_get_path_at_pos(tv, bx, by, &path, NULL, NULL, NULL))
        {
            GtkTreeModel* model = gtk_tree_view_get_model(tv);
            GtkTreeIter iter;
            if (gtk_tree_model_get_iter(model, &iter, path))
            {
                depth = gtk_tree_path_get_depth(path);
                gtk_tree_model_get(model, &iter, 0, &object, -1);
            }
            gtk_tree_path_free(path);
        }
        
        if (object) 
        {
            gtk_tooltip_set_custom(tooltip, func(object, depth));
            return TRUE;
        }
        else return FALSE;
    }
    return FALSE;
}

void gtk_fancytips_new(
        GtkTreeView* tv, FancyTipsFunc func,
        GtkFancyTipsPos pos)
{
    g_object_set(G_OBJECT(tv), "has-tooltip", TRUE, NULL);
    g_object_set_data(G_OBJECT(tv), "position", GINT_TO_POINTER(pos));
    g_signal_connect(tv, "query-tooltip", G_CALLBACK(query_tv_tooltip), func);
}



#ifdef WIN32
#define _UI_TOOLTIPS_C_
#include "lgtk2corealiasdef.c"
#endif
