/* Copyright (C) 2005 sgop@users.sourceforge.net
   This is free software distributed under the terms of the
   GNU Public License.  See the file COPYING for details. */

#ifndef _UI_TREEVIEW_H_
#define _UI_TREEVIEW_H_

#include <gtk/gtk.h>

#include "lcore/action_item.h"

/** Configure a column from a GtkTreeView. The column is set
 * resizeable and sortable, if c is greater or equal to 0.
 * @param col the column
 * @param c the data column in the model to be used for sorting, or -1
 * @param layout the layout name which is used to save the width and
 * visibility of the column, or NULL
 * @param last TRUE if its the last column of the view. Not used atm.
 */
void
ui_tv_config_default_col(GtkTreeViewColumn* col, int c,
			 const char* layout, gboolean last);

void
ui_tv_config_line_marker(GtkTreeView* tv, const char* layout,
			 int model_col);

void
ui_tv_column_set_data(GtkTreeViewColumn* col, GtkCellRenderer* rend,
		      const char* attr, int data_col);

GtkTreeViewColumn*
ui_tv_column_new(const char* title, ...);

void
ui_tv_handle_button(GtkTreeView* tv, unsigned num_actions,
		    action_item_t** actions, void* user_data);

#endif
