/* Copyright (C) 2005 sgop@users.sourceforge.net
 * This is free software distributed under the terms of the
 * GNU Public License.  See the file COPYING for details.
 */
/* $Revision: 1.4 $
 * $Date: 2006/07/22 17:11:46 $
 * $Author: sid4u $
 */

#ifndef _LIMIT_H_
#define _LIMIT_H_

#include "object.h"
#include "module.h"

G_BEGIN_DECLS

/** @defgroup LimitModule Class for handling limits
 * @ingroup LopsterLibs
 * @{ */

typedef struct _limit_t limit_t;

#define LIMIT(obj) ((limit_t*)(obj))

/** Limit class, private */
struct _limit_t {
  object_t _obj;   ///< the base class
  char* pref;
  int limit;
  int used;
};

module_t* limit_module_instance();

limit_t* limit_new(const char* name, const char* pref);
void limit_init(limit_t* lim, const char* name,
                const char* pref, unsigned def);

limit_t* limit_find(const char* name);
void limit_set_limit(limit_t* limit, int val);
int limit_get_limit(limit_t* limit);
int limit_get_used(limit_t* limit);
gboolean limit_reached(limit_t* limit);

void limits_increase(GList* limits);
void limits_decrease(GList* limits);
gboolean limits_reached(GList* limits);
//void limits_clear(GList* limits);

/** @} */

G_END_DECLS

#endif
