/* Copyright (C) 2007 The Lopster Team
 * This is free software distributed under the terms of the
 * GNU Public License.  See the file COPYING for details.
 */
/* $Revision: 1.1 $
 * $Date: 2007/09/30 09:22:35 $
 * $Author: sid4u $
 */

/**
  *
  *
  *
  **/
typedef struct {
    socket_t* socket;
    int cond;
} socket_info_t;

static unsigned InfoAllocated = 0;
socket_info_t* Info = NULL;


HWND internal_hwnd;
/*    if (internalHwnd)
        DestroyWindow(internalHwnd);*/
static void backend_clear_write(socket_t* s);
LRESULT CALLBACK back_end_internal_proc(HWND hwnd, UINT message, WPARAM wp, LPARAM lp)
{
    if (message == WM_NCCREATE) {
            return TRUE;
    } else if (message == WM_USER) {

        // socket notifier message
        long result;
        int type = -1;
		socket_t* s = Info[wp].socket;
		MSG msg;
        msg.hwnd = hwnd;
        msg.message = message;
        msg.wParam = wp;
        msg.lParam = lp;
    
        switch (WSAGETSELECTEVENT(lp)) {
			case FD_READ:
				s->priv->in_func(s);
				break;
			case FD_WRITE:
				backend_clear_write(s);
				s->priv->out_func(s);
				break;
			case FD_OOB:
				socket_done(s, ST_ERROR, "socket error");
				break;
        }
        if (type >= 0) {

	    }
        return 0;
	}

    return  DefWindowProc(hwnd, message, wp, lp);
}

static HWND back_end_create_internal_window()
{
	WNDCLASS wndclass;
	CHAR *ProviderClass = "AsyncSelect";
	HWND wnd;

	wndclass.style = CS_HREDRAW | CS_VREDRAW;
	wndclass.lpfnWndProc = (WNDPROC)back_end_internal_proc;
	wndclass.cbClsExtra = 0;
	wndclass.cbWndExtra = 0;
	wndclass.hInstance = NULL;
	wndclass.hIcon = LoadIcon(NULL, IDI_APPLICATION);
	wndclass.hCursor = LoadCursor(NULL, IDC_ARROW);
	wndclass.hbrBackground = (HBRUSH) GetStockObject(WHITE_BRUSH);
	wndclass.lpszMenuName = NULL;
	wndclass.lpszClassName = ProviderClass;

	if (RegisterClass(&wndclass) == 0)
	{
		g_log("SOCK_WIN32", G_LOG_LEVEL_WARNING, "RegisterClass() failed with error %d\n", GetLastError());
		return NULL;
	}

	if ((wnd = CreateWindowA(
		ProviderClass,
		"",
		WS_OVERLAPPEDWINDOW,
		CW_USEDEFAULT,
		CW_USEDEFAULT,
		CW_USEDEFAULT,
		CW_USEDEFAULT,
		NULL,
		NULL,
		NULL,
		NULL)) == NULL)
		{
			return NULL;
		}
	return wnd;
}


static back_end_wsa_async_set_condition(int fd, int condition)
{
    WSAAsyncSelect(fd, internal_hwnd, WM_USER , condition);	
}

static void backend_add_socket(socket_t* s)
{
    while (s->priv->fd >= (int)InfoAllocated)
    {
        unsigned num = InfoAllocated?InfoAllocated*2:16;
        Info = g_realloc(Info, sizeof(*Info)*num);
        memset(Info+InfoAllocated, 0, sizeof(*Info)*(num-InfoAllocated));
        InfoAllocated = num;
    }
	Info[s->priv->fd].socket = s;
	Info[s->priv->fd].cond = 0;

}

static void backend_remove_socket(socket_t* s)
{
    g_assert(s->priv->fd != -1);
    g_assert(s->priv->fd < (int)InfoAllocated);
    if (Info[s->priv->fd].cond)
    {
		back_end_wsa_async_set_condition(s->priv->fd, 0);
    }
	Info[s->priv->fd].socket = 0;
	Info[s->priv->fd].cond = 0;
}

static void backend_set_read(socket_t* s)
{
	int condition = 0;
    g_assert(s->priv->fd != -1);
    g_assert(s->priv->fd < (int)InfoAllocated);
	
    if (! (Info[s->priv->fd].cond & FD_READ)) {
		g_log("SOCK_WIN32", G_LOG_LEVEL_WARNING, "backend_set_read");
        condition |= FD_READ;
		Info[s->priv->fd].cond |= FD_READ;
		if (! (Info[s->priv->fd].cond & FD_OOB))
			condition |= FD_OOB;
	}
	if (Info[s->priv->fd].cond & FD_WRITE)
        condition |= FD_WRITE;   

    if (condition != 0)
    {
		back_end_wsa_async_set_condition(s->priv->fd, condition);
	}
}

static void backend_clear_read(socket_t* s)
{
	int condition = 0;
	g_assert(s->priv->fd != -1);
    g_assert(s->priv->fd < (int)InfoAllocated);
	
    if (Info[s->priv->fd].cond & FD_READ) {
		g_log("SOCK_WIN32", G_LOG_LEVEL_WARNING, "backend_clear_read");
        condition &= ~FD_READ;
		Info[s->priv->fd].cond &= ~FD_READ;
	}
	if (Info[s->priv->fd].cond & FD_WRITE) {
        condition |= FD_WRITE;   
		if (! (Info[s->priv->fd].cond & FD_OOB))
			condition |= FD_OOB;
	}
    if (condition != 0)
    {
		back_end_wsa_async_set_condition(s->priv->fd, condition);
	}
}

static void backend_set_write(socket_t* s)
{
	int condition = 0;
	g_assert(s->priv->fd != -1);
    g_assert(s->priv->fd < (int)InfoAllocated);

    if (! (Info[s->priv->fd].cond & FD_WRITE)) {
		g_log("SOCK_WIN32", G_LOG_LEVEL_WARNING, "backend_set_write");
        condition |= FD_WRITE;
		Info[s->priv->fd].cond |= FD_WRITE;
		if (! (Info[s->priv->fd].cond & FD_OOB))
			condition |= FD_OOB;
	}
	if (Info[s->priv->fd].cond & FD_READ)
        condition |= FD_READ;   

    if (condition != 0)
    {
		back_end_wsa_async_set_condition(s->priv->fd, condition);
	}
}

static void backend_clear_write(socket_t* s)
{
	int condition = 0;
    g_assert(s->priv->fd != -1);
    g_assert(s->priv->fd < (int)InfoAllocated);


    if (Info[s->priv->fd].cond & FD_WRITE) {
		g_log("SOCK_WIN32", G_LOG_LEVEL_WARNING, "backend_clear_write");
        condition &= ~FD_WRITE;
		Info[s->priv->fd].cond &= ~FD_WRITE;
	}
	if (Info[s->priv->fd].cond & FD_READ) {
        condition |= FD_READ;   
		if (! (Info[s->priv->fd].cond & FD_OOB))
			condition |= FD_OOB;
	}
    if (condition != 0)
    {
		back_end_wsa_async_set_condition(s->priv->fd, condition);
	}
}

static void backend_init()
{
	internal_hwnd = back_end_create_internal_window();
	if (!internal_hwnd)
	{
		g_log("SOCK_WIN32", G_LOG_LEVEL_WARNING, "CreateWindow() failed with error %d\n", GetLastError());
		g_assert(FALSE);
	}
}

static void backend_exit()
{
	if (internal_hwnd)
        DestroyWindow(internal_hwnd);
}
