/* Copyright (C) 2005-2007 Lopster Team
 * This is free software distributed under the terms of the
 * GNU Public License.  See the file COPYING for details.
 */
/* $Revision: 1.2 $
 * $Date: 2007/11/21 20:18:23 $
 * $Author: sgop $
 */

#ifndef _L_TIMER_H_
#define _L_TIMER_H_

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif
/*
#if TIME_WITH_SYS_TIME
# include <sys/time.h>
# include <time.h>
#else
# if HAVE_SYS_TIME_H
#  include <sys/time.h>
# else
#  include <time.h>
# endif
#endif
*/
#include "module.h"


G_BEGIN_DECLS


/** \defgroup TimerClasses Timer Interface */
/*@{*/

typedef gboolean (*PeriodicFunc)(void* data);

void lopster_call_periodic(unsigned timeout, PeriodicFunc func, void* data);

void lopster_cancel_call(PeriodicFunc func);


//EXPORT 
#ifdef WIN32
time_t get_current_time();
#define CurrentTime get_current_time()
//__declspec(dllexport) time_t CurrentTime;
#else
extern time_t CurrentTime;
#endif


guint lopster_timeout_add (guint interval, GSourceFunc function, gpointer data);
guint lopster_idle_add (GSourceFunc function, gpointer data);
void lopster_timeout_remove (guint id);
void lopster_idle_remove(guint id);

module_t* timer_module_instance();


/*@}*/

G_END_DECLS

#endif // _L_TIMER_H_
