/* Copyright (C) 2005 sgop@users.sourceforge.net
   This is free software distributed under the terms of the
   GNU Public License.  See the file COPYING for details. */

#ifndef _LIB_SEARCH_H_
#define _LIB_SEARCH_H_

#include "module.h"
#include "search.h"

G_BEGIN_DECLS

/** \defgroup LibSearchModule Searching in the library
 *
 * These searches are quite fast, as the files are internally
 * hashed. This module only searches for shared files, thus it's
 * basically used to answer search requests from a network.
 *
 * @ingroup LibraryModule
 */
/*@{*/

module_t* lib_search_module_instance();

GList* lib_search_do(search_pattern_t* search);

/*@}*/

G_END_DECLS
#endif
