/* Copyright (C) 2005 sgop@users.sourceforge.net This is free software
 * distributed under the terms of the GNU Public License.  See the
 * file COPYING for details.
 */
/* $Revision: 1.17 $
 * $Date: 2007/10/11 11:57:38 $
 * $Author: sid4u $
 */

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <stdint.h>
#include <stdio.h>
#include <string.h>
#include <signal.h>

#include "lopster.h"
#include "l_base.h"
#include "l_i18n.h"
#include "module.h"
#include "utils.h"

/** \mainpage The Lopster Core Reference
*/

static void sigterm_handler(int val)
{
    (void)val;
    lopster_termination_request(LOPSTER_EXIT_NOW);
}


int main(int argc, char** argv)
{

    printf("Starting lopster\n");

    bindtextdomain(GETTEXT_PACKAGE, LOPSTER_LOCALE_DIR);

    bind_textdomain_codeset(GETTEXT_PACKAGE, "UTF-8");
    textdomain(GETTEXT_PACKAGE);
    
    signal(SIGPIPE, SIG_IGN);

    signal(SIGTERM, sigterm_handler);
    // FIXME: handle SIGSEGV
    // FIXME: handle SIGINT
    
    lopster_module_instance(&argc, &argv);
    
    modules_initialize();
    modules_run       ();
    modules_shutdown  ();
    
    return 0;
}
