/* Copyright (C) 2005 sgop@users.sourceforge.net
 * This is free software distributed under the terms of the
 * GNU Public License.  See the file COPYING for details.
 */
/* $Revision: 1.8 $
 * $Date: 2007/05/23 20:21:53 $
 * $Author: sid4u $
 */

#ifndef _MTYPES_H_
#define _MTYPES_H_

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <glib.h>

#include "module.h"

G_BEGIN_DECLS

// major media types
#define MEDIA_INVALID      -1
#define MEDIA_UNKNOWN       0
#define MEDIA_AUDIO         1
#define MEDIA_VIDEO         2
#define MEDIA_APPLICATION   3
#define MEDIA_IMAGE         4
#define MEDIA_DOCUMENT      5
#define MEDIA_FOLDER        6
#define MEDIA_ANY           7

typedef struct _mtype_t mtype_t;
typedef struct _appl_t appl_t;

struct _mtype_t {
    GList* app;
    char* download;
    int type;
};

module_t* mtype_module_instance();

mtype_t* mtype_find(int no);
void mtype_free(mtype_t* mtype);
void mtype_clear_all(void);
void mtype_save(void);


appl_t* app_new(const char* command, const char* label);
void app_set_multiple(appl_t* appl, gboolean multiple);
void app_ref(appl_t* appl);
void app_unref(appl_t* appl);
const char* app_get_command(appl_t* appl);
const char* app_get_name(appl_t* appl);
gboolean app_get_multiple(appl_t* appl);
gboolean app_equal(appl_t* app1, appl_t* app2);


char* mtype_get_mime_type(const char* name, int* media);
const char* mtype_get_folder(int type);
void mtype_set_folder(int type, const char* path);
GList* mtype_get_applications(char* mime, int type, GList** desktop_apps);
void mtype_run_application(appl_t* app, GList* items);

const char* int2media(int no, int mode);
int media2int(const char* media);

void mtype_browse(const char* address);
void mtype_mail(const char* address);

G_END_DECLS

#endif
