#ifndef _BANDWIDTHBAR_H_
#define _BANDWIDTHBAR_H_

#include <QWidget>

class StyleCore;
class BandwidthBar : public QWidget
{
   // Q_OBJECT

public:
    BandwidthBar(QWidget *parent = 0);
    /*BandwidthBar(QString bname, volume_t* volume, rate_t* rate, QWidget *parent = 0);*/

    void setName(QString bname) {this->bname = bname;}
    QString name() const {return this->bname;}

    void setVolume(volume_t* volume);
    volume_t* volume() const  {return this->bvolume;}
    
    void setRate(rate_t* rate) {this->brate = rate;}
    rate_t* rate() const  {return this->brate;}
    static void ui_bandwidth_force_update(void* dummy, BandwidthBar *bar);

    QSize minimumSizeHint() const;  
    void draw(QPainter *painter);
private:
    unsigned int calc_x(quint32 val, quint32 max, int width);
protected:
    void paintEvent(QPaintEvent *event);
    void mousePressEvent(QMouseEvent *event);
    void mouseReleaseEvent(QMouseEvent *event);
    void mouseMoveEvent (QMouseEvent *event);
private:
    QColor ucolor[5]; 
    QString bname;
    volume_t* bvolume;
    rate_t* brate;
    quint32 brange;
    int x_drag_start;
    int drag_range;
    int grid_height;
    bool mouse_pressed;
    StyleCore *style_core;
};

class RateProgressWidget : public QWidget
{
public:
    RateProgressWidget(QWidget *parent=0);
    QSize minimumSizeHint() const;  
    void draw(QPainter *painter);    
    static void ui_bandwidth_force_update(void* dummy, RateProgressWidget *widget);
    void setVolume(volume_t* volume);
    volume_t* volume() const  {return this->bvolume;}    
    void setRate(rate_t* rate) {this->brate = rate;}
    rate_t* rate() const  {return this->brate;}
    unsigned int calc_x(quint32 val, quint32 max, int width);
protected:
    void paintEvent(QPaintEvent *event);   
private:
    quint32 brange;
    volume_t* bvolume;
    rate_t* brate;
};

class BandwidthProgress : public QWidget
{
public:
    BandwidthProgress(const QString& text, QWidget *parent=0);
    QSize minimumSizeHint() const; 
    RateProgressWidget *pbar;
private:
    QLabel *label;
};

#endif // _BANDWIDTHBAR_H_
