/****************************************************************************
**
** Copyright (c) 2007 Trolltech ASA <info@trolltech.com>
**
** Use, modification and distribution is allowed without limitation,
** warranty, liability or support of any kind.
**
****************************************************************************/


#ifndef COMMANDLINK_H
#define COMMANDLINK_H

#include <QPushButton>
#include "ui_utils.hpp"

class QT4_UI_EXPORT CommandLink : public QPushButton 
{
public:
    CommandLink(QWidget* parent = 0);
    QSize sizeHint() const;
    void setDescription(const QString &description) { 
        descriptionText = description;
        update();
    }
    QString description() const {
        return descriptionText;
    }
protected:
    void paintEvent(QPaintEvent *);
    QString descriptionText;
    QColor currentColor;
};

#endif // COMMANDLINK_H
