/*
 * WengoPhone, a voice over Internet phone
 * Copyright (C) 2004-2007  Wengo
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

  /*
  * This nice expanding widget is slightly modified version of WengoPhone ExpandButton, but adding a bit of 
  * more fancy icons, and label
  */


#ifndef EXPANDWIDGET_H
#define EXPANDWIDGET_H

#include <QtGui/QFrame>

class QToolButton;
class QLabel;
//class ExpandButton;

class ExpandWidget : public QFrame {
    Q_OBJECT
public:
	enum ExpandDirection { ED_Up, ED_Down };
	ExpandWidget(const QString &res, QWidget* parent);
    void setText(const QString &text);
    void setToggle(bool toggled);
	/**
	 * Defines whether the arrow should point down (default) or up.
	 */
	void setExpandDirection(ExpandDirection);
	ExpandDirection expandDirection() const;
	virtual QSize sizeHint() const;

protected:
    void leaveEvent(QEvent *event);
    void mouseReleaseEvent(QMouseEvent *event);
    void mouseMoveEvent (QMouseEvent *event);

signals:
    void expand_toggled(bool);

private slots:
    void on_toggle(bool);

private:
    void setExpandButtonPixmap(bool hover);

private:
    bool toggle;
    QLabel *expand;
    QLabel *icon;
    QLabel *label;
	ExpandDirection _expandDirection;
};


#endif //EXPANDWIDGET_H
