/* Copyright (C) 2007 The Lopster Team
 * This is free software
 * distributed under the terms of the GNU Public License.  See the
 * file COPYING for details.
 */

/* $Revision: 1.7 $
 * $Date: 2007/09/11 07:32:11 $
 * $Author: sid4u $
 */

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include "ui_main.hpp"
#include "LTabWidget.hpp"


LTabWidget::LTabWidget(QWidget *parent, QTabWidget::TabPosition position)
        : QTabWidget(parent)
{
    setTabPosition(position);
    close_button = new QToolButton(this);
    close_button->setIcon(LICON(":/close.png", LOPSTER_TOOL_ICON));
    connect(close_button, SIGNAL(clicked()), this, SLOT(on_close_tab()));

    // FIXME : assume the side too, but not used yet on lopster 
    // FIXME : add checking for left to right users too..they may like to have it on the left side
    if (position == QTabWidget::North)
    {
        setCornerWidget(close_button);
    }
    else
    {
        setCornerWidget(close_button, Qt::BottomRightCorner);
    }
}

void LTabWidget::on_close_tab()
{
    if (count() == 0)
    {
        return;
    }
    emit close_tab(currentIndex());
}
