#ifndef _LTABWIDGET_H_
#define _LTABWIDGET_H_

#include <QTabWidget>
#include <QHash>
#include <QToolButton>
#include "lcore/object.h"

class LTabWidget : public QTabWidget
{
    Q_OBJECT
public:
    LTabWidget(QWidget * parent = 0, QTabWidget::TabPosition position = QTabWidget::North );
    void ltab_set_object(QWidget * w, object_t* object) {tab_storage[w] = object; }
    object_t* ltab_get_object(QWidget * w) { return tab_storage[w];}
private slots:
    void on_close_tab();
signals:
    void close_tab(int);
private:
    QToolButton *close_button;
    QHash <QWidget *, object_t*> tab_storage;
};
#endif // _LTABWIDGET_H_
