#include <QWidget>
#include <QHBoxLayout>
#include <QLabel>
#include "ui_utils.hpp"

class QVBoxLayout;
class ModuleLabel : public QFrame
{
public:
    ModuleLabel(QWidget *parent=0);
    void set_text(const QString &title);
	void hide_icon(bool value);
	void set_icon(const QString &res);
    QSize minimumSizeHint() const;  
private:
    QLabel *m_icon;
    QLabel *m_label;
    QHBoxLayout *hlayout;
};

class ModuleBody : public QFrame
{
public:
    ModuleBody(QWidget *parent=0);
};

class QT4_UI_EXPORT ModuleWidget : public QWidget
{

public:
    ModuleWidget(QWidget *parent=0);   
    void set_icon(const QString &res);
    void hide_icon(bool hide);

    void set_title(const QString &title);
    void set_widget(QWidget *widget);
    
    ModuleLabel *get_label() {return m_label;}
    ModuleBody *get_body() {return m_body;}

    static ModuleWidget *CreateSearchModuleWidget(QWidget *parent=0);
    static ModuleWidget *CreateStandardModule(QWidget *parent=0);
private:
	ModuleLabel *m_label;
    ModuleBody  *m_body;
    QVBoxLayout *body_layout;
};
