#ifndef _UI_LIBRARY_H
#define _UI_LIBRARY_H

#include "lcore/library.h"
#include "CustomWidgets.hpp"
#include "ui_utils.hpp"
#include "widgets/LibraryPage.h"

class QT4_UI_EXPORT LibraryPage : public LWidget, private Ui::LibraryPage
{
   Q_OBJECT

   public:
    LibraryPage(QWidget *parent = 0);
    ~LibraryPage();
    void loadCoreData();
    void ui_lib_set_library_to_load(library_t* lib) {lib_to_load = lib;}
    void ui_lib_update(library_t* lib);    
    void ui_lib_destroy(library_t* lib);
    
    static LibraryPage* getLibraryPage();    
    static void s_ui_lib_working(gboolean val);
    static void s_ui_lib_destroy(library_t* lib);
    static void s_ui_lib_new(library_t* lib);    

private slots:
    void ui_lib_on_library_save();
    void ui_lib_on_library_rebuild();
    void ui_lib_on_delete_list(QAction *);
    void ui_lib_on_load_list(QAction *);
    void ui_lib_on_add_folder();

private:
    int  ui_lib_populate_load_delete_popup(QMenu *item_load, QMenu *item_delete);
    void ui_lib_create_manage_popup();

private:
    library_t* current_lib;
    library_t* lib_to_load;
    QMenu *lib_manager;
    bool ready;
};

#endif //_UI_LIBRARY_H
