#ifndef _UI_NETWORK_H
#define _UI_NETWORK_H

#include "lcore/plugin.h"
#include "CustomWidgets.hpp"
#include "ui_utils.hpp"
#include "widgets/NetworkPage.h"
#include "widgets/PluginSummaryWidget.h"

class PluginSummary: public QWidget, private Ui::PluginSummaryWidget
{
   Q_OBJECT
public:
    PluginSummary(QWidget *parent = 0, int plugin_id =-1);
    void ui_net_summary_update_status(online_status_t* status);
private slots:
    void do_auto();
    void do_discon();
private:
    QString ui_net_summary_status_to_number(int value);
private:
    plugin_t* m_plugin;
};


#define MAX_PLUGIN  9
class QT4_UI_EXPORT NetworkPage : public LWidget, private Ui::NetworkPage
{
    Q_OBJECT
public:
    NetworkPage(QWidget *parent = 0);
    ~NetworkPage();
    void loadCoreData( ) {}
    void ui_network_add_summary(int plugin_id);
	static void ui_network_add_page(int plugin_id, QWidget* widget);
	static void ui_network_remove_page(QWidget* widget);
    static void s_ui_network_online_status_changed(online_status_t* status, PluginSummary *summary);
private:
    int summary_cnt;
    QWidget *current_widget;
    QHBoxLayout *current_layout;
    QVBoxLayout *main_layout;
};

#endif //_UI_NETWORK_H
