/* Copyright (C) 2005 Lopster Team. This is free software
 * distributed under the terms of the GNU Public License.  See the
 * file COPYING for details.
 */
/* $Revision: 1.1 $
 * $Date: 2007/09/11 07:22:34 $
 * $Author: sid4u $
 */

#ifndef _UI_TIMER_H
#define _UI_TIMER_H


#include <glib.h>
#include <QTimer>
#include <QEvent>
#include "ui_utils.hpp"

class TimerEventFilter : public QObject
{
public:
    TimerEventFilter(QObject *parent) : QObject(parent) {}
protected:
    bool eventFilter(QObject *obj, QEvent *event);
};

class TimerEvent : public QEvent
{
public:
   inline TimerEvent(uint id, uint interval, GSourceFunc function, gpointer data) : QEvent((QEvent::Type) \
            (QEvent::User+TIMER_EVENT_ID) ) { \
            this->id = id; this->interval = interval; this->function = function; this->data = data;}
    uint id;
    uint interval;
    GSourceFunc function;
    gpointer data;
};

class TimerRemoveEvent : public QEvent
{
public:
   inline TimerRemoveEvent(uint id) : QEvent((QEvent::Type) (QEvent::User+TIMER_REMOVE_EVENT_ID) ) { \
            this->id = id; }
    uint id;
};

class LopsterUiTimer : public QTimer
{
    Q_OBJECT
public:
    LopsterUiTimer(guint interval, GSourceFunc function, gpointer data);
    ~LopsterUiTimer();

    static uint qt_timeout_add(guint interval, GSourceFunc function, gpointer data);
    static uint qt_idle_add(GSourceFunc function, gpointer data);
    static gboolean qt_timeout_remove(uint id);
    static void qt_timers_cleanup();

private slots:
    void OnTimerReached( );

private:
    void customEvent(QEvent* );
    guint interval;
    GSourceFunc function;
    gpointer data;
};

#endif // _UI_TIMER_H
