/* Copyright (C) 2007 The Lopster Team
 * This is free software
 * distributed under the terms of the GNU Public License.  See the
 * file COPYING for details.
 */

/* $Revision: 1.9 $
 * $Date: 2008/12/23 13:38:14 $
 * $Author: sgop $
 */

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <QMessageBox>
#include <QIcon>
#include "lcore/l_base.h"
#include "ui_utils.hpp"
#include "ui_main.hpp"


static int SelectionDepth = -1;
static bool SelectionInverted = false;


QWidget* findWidgetByName(QString name)
{
    foreach (QWidget *widget, QApplication::allWidgets()) {
        if (widget->objectName() == name)
        {           
            return widget;
        }                   
    }
    return NULL;
}

QIcon create_icon(const QString filename){
    QIcon icon;
    QImage image(filename);
    if (!image.isNull())
    icon.addPixmap(QPixmap::fromImage(image), QIcon::Normal, QIcon::On);
    return icon;
}

QIcon create_icon(const char* filename) {
    QIcon icon;
    const char* pathname = NULL;

    if (!filename || !filename[0]) {
        return QIcon();
    }
    
    /* pathname = lopster_pixmap_find(filename); */
    /* if (!pathname) { */
    /*      g_log("QT4", G_LOG_LEVEL_WARNING, "Couldn't find pixmap file: %s", filename); */
    /*    return QIcon(); */
    /*} */

    QImage image(qfu(filename));
    if (!image.isNull()) {
        icon.addPixmap(QPixmap::fromImage(image), QIcon::Normal, QIcon::On);
    }
    else {
        return QIcon();
    }
    return icon;
}

QIcon create_icon_from_lopster_pixmap(const char* filename) {
    QIcon icon;
    const char* pathname = NULL;

    if (!filename || !filename[0]) {
        return QIcon();
    }
    QString img_file = qfu("%1").arg(filename);
    QImage image(img_file);
    if (!image.isNull())
        icon.addPixmap(QPixmap::fromImage(image), QIcon::Normal, QIcon::On);

    return icon;
}

int rate_from_value(int value)
{
    int rate = 0;
    if (value >= 0 && value < 250) {
        rate = 1 + int(value * 0.124);
    } else if (value < 500) {
        rate = 32 + int((value - 250) * 0.384);
    } else if (value < 750) {
        rate = 128 + int((value - 500) * 1.536);
    } else {
        rate = 512 + int((value - 750) * 6.1445);
    }
    return rate;
}

int rate_to_value(int rate)
{
    int value = 0;
    if (rate >= 0 && rate < 32) {
        value = int((rate-1) / 0.124);
    } else if (rate < 128) {
        value = int((rate-32) / 0.384) + 250;
    } else if (rate < 512) {
        value = int((rate-128) / 1.536) + 500;
    } else {
        value = int((rate-512) / 6.1445) + 750 ;
    }
    return value;
}
