#ifndef _UPLOADVIEW_H_
#define _UPLOADVIEW_H_


#include <QtGui>
#include "lcore/upload.h"
#include "CustomWidgets.hpp"
#include "ui_treeview.hpp"




class UploadInfoLabels
{
public:
    QLabel *bandwidth;
    QLabel *uploaded;
    QLabel *limit;
    QSlider *slider;
};

class UploadItem;

class UploadTreeView : public UiTreeView
{
   Q_OBJECT
public:
    UploadTreeView(QWidget *parent = 0);
    void ui_upload_set_monitors( );

    static void ui_upload_periodic_update(void);
    static void ui_upload_show(upload_t* upload);
    static void ui_upload_update(upload_t* upload);
    static void ui_upload_hide(upload_t* upload);

    static void s_on_limit_changed(limit_t* limit, QLabel *label);
    static void s_on_band_changed(limit_t* limit, QLabel *label);
    static void s_on_load_changed(volume_t* volume, QLabel *label);
    void set_update_labels(UploadInfoLabels *update) { this->update = update;} 

private:
    UploadInfoLabels *update; 
};


class UploadTreeViewDelegate : public QItemDelegate
{
    Q_OBJECT
public:
    UploadTreeViewDelegate(QWidget *parent, UploadTreeView *tree_view);

    void paint(QPainter *painter, const QStyleOptionViewItem &option,
                      const QModelIndex &index ) const;

private slots:
    void style_changed(const QString &style);

private:
    UploadTreeView *tree_view;
    QColor ucolor[5]; //back,border,active,finished,progress

};

#include "widgets/UploadViewWidget.h"

class UploadView :  public LWidget, private Ui::UploadViewWidget
{
public: 
    UploadView(QWidget *parent = 0);
    ~UploadView();
    void loadCoreData( );
private:
	UploadInfoLabels *update;
};

#endif //_UPLOADVIEW_H_
