/* Copyright (C) 2005 sgop@users.sourceforge.net
   This is free software distributed under the terms of the
   GNU Public License.  See the file COPYING for details. */

#ifndef _STORAGE_H_
#define _STORAGE_H_

#include <glib.h>

G_BEGIN_DECLS

typedef void (*StorageTraverseFunc)(void* object, gpointer data);
typedef struct _storage_t storage_t;

storage_t* storage_new(GDestroyNotify destroy);
void storage_add_compare_func(storage_t* storage, GCompareFunc compare, gboolean slow);
void* storage_find  (storage_t* storage, void* object);
void storage_remove (storage_t* storage, void* object);
void storage_steal  (storage_t* storage, void* object);
void storage_insert (storage_t* storage, void* object);
int  storage_count  (storage_t* storage);
void storage_foreach(storage_t* storage, StorageTraverseFunc func, gpointer data);
void storage_destroy(storage_t* storage);
void storage_clear  (storage_t* storage);

G_END_DECLS
#endif
