/* Copyright (C) 2005 sgop@users.sourceforge.net
   This is free software distributed under the terms of the
   GNU Public License.  See the file COPYING for details. */

#ifndef _TCP_SOCKET_H_
#define _TCP_SOCKET_H_

#include "b_socket.h"
#include "module.h"

G_BEGIN_DECLS

/** @defgroup TSocketModule TCP socket class
 * @ingroup SocketClasses
 */
/*@{*/

#define TSOCK(s) ((tcp_socket_t*)(s))

typedef struct _tcp_socket_t tcp_socket_t;

/** TCP socket class */
struct _tcp_socket_t {
  b_socket_t _socket; ///< base class
  ip_t ip;            ///< the ip
  port_t port;        ///< the port
};


module_t* tsocket_module_instance();

gboolean tcp_socket_end(tcp_socket_t* sock, const char* message);
void tcp_socket_destroy(tcp_socket_t* sock);
void tcp_socket_init(tcp_socket_t* socket, const char* name, int timeout);
tcp_socket_t* tcp_socket_new(const char* name, int timeout);

void tcp_socket_move(tcp_socket_t* dest, tcp_socket_t* src, gboolean copy_buffer);
int tcp_socket_connect(tcp_socket_t* sock, ip_t ip, port_t port);
void tcp_socket_send_str(tcp_socket_t* socket, const char* message);
void tcp_socket_send_bin(tcp_socket_t* socket, const char* message, int len);

/*@}*/

G_END_DECLS

#endif
