/* Copyright (C) 2007 The Lopster Team
 * This is free software distributed under the terms of the
 * GNU Public License.  See the file COPYING for details.
 */
/* $Revision: 1.2 $
 * $Date: 2007/11/23 08:36:02 $
 * $Author: sid4u $
 */

#ifndef _URL_H_
#define _URL_H_

#include "object.h"

G_BEGIN_DECLS

typedef struct {
    object_t _object;
    char* proto;
    char* host;
    ip_t ip;
    port_t port;
    char* doc;
} url_t;

url_t* url_parse(const char* url);
url_t* url_new(const char* proto, const char* host, port_t port, const char* doc);
void url_destroy(url_t* url);
gboolean url_equal(url_t* url1, url_t* url2);
char* url_format(url_t* url);

G_END_DECLS

#endif
