/* Copyright (C) 2005 sgop@users.sourceforge.net
 * This is free software distributed under the terms of the
 * GNU Public License.  See the file COPYING for details.
 */
/* $Revision: 1.5 $
 * $Date: 2006/07/22 17:11:48 $
 * $Author: sid4u $
 */

#ifndef _ZBUFFER_H_
#define _ZBUFFER_H_

#include "buffer.h"

G_BEGIN_DECLS

/** \defgroup ZBufferModule Compressing and decrompressing data
 * @ingroup LopsterLibs
 */
/*@{*/

/** @name Compression types */
/*@{*/
#define COMPRESS_UNKNOWN   0  ///< Unknown compression
#define COMPRESS_ZLIB      1  ///< Compression using the zlib
#define COMPRESS_BZIP2     2  ///< Compression using the bzip2
#define COMPRESS_HUFFMAN   3  ///< Compression using huffman codes
/*@}*/

/** The compression class */
typedef struct _compress_t compress_t;

compress_t* compress_new(int type, gboolean compress,
                         buffer_t* in, buffer_t* out);
int compress_action(compress_t* comp, gboolean finish);
void compress_destroy(compress_t* comp);

/*@}*/

G_END_DECLS

#endif
