/* Copyright (C) 2005 sgop@users.sourceforge.net
 * This is free software distributed under the terms of the
 * GNU Public License.  See the file COPYING for details.
 */
/* $Revision: 1.6 $
 * $Date: 2007/11/15 13:17:43 $
 * $Author: sid4u $
 */

#include "lcore/l_base.h"
#include "lcore/utils.h"
#include "lcore/version.h"

#include "bt.h"
#include "bt_network.h"
#include "bt_ui.h"
#include "bt_users.h"
#include "bt_download.h"

#ifndef WIN32
int BT_ID = -1;
#else
int bt_id = -1;
#endif

static void bt_init()
{
}

static void bt_run()
{
}

static void bt_exit()
{
}

static void bt_plugin_start(plugin_t* plugin)
{
    plugin_init(plugin, "BitTorrent Module",
                (ModuleFunc)bt_init, (ModuleFunc)bt_run, (ModuleFunc)bt_exit);
#ifndef WIN32
    BT_ID = plugin->ID;
#else    
    bt_id = plugin->ID;
#endif    
    plugin->connect = bt_connect_change;

    module_require(base_module_instance);
    module_require(bt_ui_module_instance);
    module_require(bt_user_module_instance);
    module_require(bt_net_module_instance);
    module_require(bt_download_module_instance);
}


void plugin_initialize(plugin_info_t* info)
{
    info->name       = g_strdup("BitTorrent");
    info->sname      = g_strdup("BT");
    info->copyright  = g_strdup("Copyright  2005-2006 The Lopster Project");
    info->if_version = IF_VERSION;
    info->pl_version = 0x00010200;  // 0.1.2
    info->icon       = g_strdup("bt_icon.png");
    info->license    = g_strdup("GPL (GNU General Public License)");
    info->website    = g_strdup("http://lopster.sourceforge.net");
    info->comment    = g_strdup("Plugin which implements BitTorrent.");
    info->authors    = g_list_append
        (info->authors, g_strdup("Markus Lausser <sgop@users.sourceforge.net>"));
    info->authors    = g_list_append
        (info->authors, g_strdup("Siddique Vally-Adam <sid4u@users.sourceforge.net>"));
    info->start      = bt_plugin_start;
#ifdef PACKAGE_SOURCE_DIR
    lopster_pixmap_dir_add(SDIR(PACKAGE_SOURCE_DIR) SDIR("plugin") 
                           SDIR("bittorrent") "pixmaps");
#endif
}

#ifdef WIN32
int bt_plugin_get_id( )
{
    return bt_id;
}
#endif
