/* Copyright (C) 2005 (sid4u@users.sourceforge.net) 
	 mostly inspired from (sgop@users.sourceforge.net) work on napster/directconnect plugin
   This is free software distributed under the terms of the
   GNU Public License.  See the file COPYING for details. */

#ifndef _BT_H_
#define _BT_H_

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include "lcore/plugin.h"
#include "lcore/chat.h"
#include "lcore/win32_defs.h"

G_BEGIN_DECLS

#ifndef WIN32
extern int BT_ID;
#else
int bt_plugin_get_id( );
#define BT_ID bt_plugin_get_id( )
#endif

/*
There are mainly two conventions how to encode client and client version information into the peer_id, Azureus-style and Shadow's-style.
Azureus-style uses the following encoding: '-', two characters for client id, four ascii digits for version number, '-', followed by random numbers.
For example: '-AZ2060-'...
Shadow's style uses the following encoding: one ascii alphanumeric for client identification, three ascii digits for version number, '----', followed by random numbers.
For example: 'S587----'...
Bram's client now uses this style... 'M3-4-2--'.
*/
// TODO: Automatic generate a BT_PEER_ID with prefix and random number
#define BT_PEER_ID	"-LP2200-012345678912"

void bt_plugin_init(plugin_t* plugin);

G_END_DECLS

#endif
