/* Copyright (C) 2005 sgop@users.sourceforge.net
 * This is free software distributed under the terms of the
 * GNU Public License.  See the file COPYING for details.
 */
/* $Revision: 1.3 $
 * $Date: 2006/07/23 08:11:44 $
 * $Author: sid4u $
 */

#ifndef _BT_ENC_H_
#define _BT_ENC_H_

#include <glib.h>

#define BT_BENC_DIC     1
#define BT_BENC_LIST    2
#define BT_BENC_STR     3
#define BT_BENC_INT     4

typedef struct {
    unsigned type;
    union {
        GList* pairs;
        GList* list;
        gint64 number;
        char* str;
    };
    const char* dic_begin_memory_offset;
    const char* dic_end_memory_offset;
    int str_size;
} bt_value_t;


bt_value_t* bt_benc_value_find_dic(bt_value_t* value, char* name);
gboolean bt_benc_value_get_string(bt_value_t* value, char** str);
gboolean bt_benc_value_get_int(bt_value_t* value, gint64* val);

bt_value_t* bt_benc_parse_from_data(const char* buffer, unsigned size);
void bt_benc_parse_from_data_dumper(const char* buffer, unsigned size);
void bt_benc_destroy(bt_value_t* torrent);

#endif
