/* Copyright (C) 2005 The Lopster Team
 * This is free software distributed under the terms of the
 * GNU Public License.  See the file COPYING for details.
 */


/* $Revision: 1.4 $
 * $Date: 2007/09/24 20:46:59 $
 * $Author: sid4u $
 */

#include <glib.h>
#include "lcore/utils.h"
#include "bt_file.h"


static void bt_file_init(bt_file_t* file, const char* path, 
                         const char* filename, int length)
{
    //TODO : implement path cutting in GList
    if (path) file->path = g_list_append(file->path, g_strdup(path));
    file->filename = g_strdup(filename);
    file->length = length;
    file->begin_offset = -1;
    file->end_offset = -1;
    file->priority = BT_NORMAL;
}

static bt_file_t* bt_file_new(const char* path, const char* filename, int length)
{
    bt_file_t* file = g_malloc0(sizeof(*file));
    bt_file_init(file, path, filename, length);
    return file;
}

/*
void bt_file_update_path( bt_file_t* file, char* path ) {
	
}
*/
void bt_file_update_filename( bt_file_t* file, const char* filename )
{
    g_free(file->filename);
    file->filename = g_strdup(filename);
}

void bt_file_add_path(bt_file_t* file, const char* path)
{
    if (path) file->path = g_list_append(file->path, g_strdup(path));
}

bt_file_t* bt_file_on_new()
{
    return bt_file_new(NULL, NULL, 0);
}

void bt_filepath_display(bt_file_t* file)
{
    GList* dlist;
    
    for (dlist = file->path; dlist; dlist = dlist->next)
    {
        char* path = dlist->data;
        printf("%s\\",path);
    }
}

void bt_file_display_file(bt_file_t* file)
{
		if (file == NULL)
    {
        printf("bt_torrent_display_files : FILE IS NULL \n");
        return;
		}
		
		printf("File attribute : \n");
		printf(" - PATH -> ");
		bt_filepath_display(file);
		printf("\n");
		printf(" - FILENAME -> %s \n",file->filename);
		printf(" - PIECES -> TODO \n");
		printf(" - LENGTH -> %d \n", file->length);
		printf(" - BEGIN_OFFSET -> %d \n", file->begin_offset);
		printf(" - END_OFFSET -> %d \n", file->end_offset);
		printf(" - PRIORITY -> %d \n", file->priority);
}

