/* Copyright (C) 2005 The Lopster Team
 * This is free software distributed under the terms of the
 * GNU Public License.  See the file COPYING for details.
 */


/* $Revision: 1.3 $
 * $Date: 2007/09/24 20:46:59 $
 * $Author: sid4u $
 */

#ifndef _BT_FILE_H_
#define _BT_FILE_H_

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif


enum {
	BT_LOW=1,
	BT_NORMAL,
	BT_HIGH	
};


//TODO:utf8 support (path and filename can have a second part in the torrent in utf8)
typedef struct {
	GList* path; // parent directories all from the first to the lowest.
	char* filename;
	int fd; // File descriptor that may be opened in WRITE mode when we want to write to, else always null
	GList* pieces; // List of pieces related to that file in order. (for unique file selection purpose, or priority)
	int length; // Length of the file (case of unique file)
	int begin_offset; // offset for the first piece where the file begins (case of multiple files)
	int end_offset; // offset for the latest piece where the file end (case of multiple files)
	int priority; // BT_HIGH, BT_NORMAL, BT_LOW (case of multiple files)
} bt_file_t;


void bt_file_update_filename( bt_file_t* file, const char* filename );
void bt_file_update_length( bt_file_t* file, int length );
void bt_file_add_path( bt_file_t* file, const char* path );

bt_file_t* bt_file_on_new();

void bt_file_display_file(bt_file_t* file);

#endif //_BT_FILE_H_
