/* Copyright (C) 2005-2006 (C) Lopster Team
 * This is free software distributed under the terms of the
 * GNU Public License.  See the file COPYING for details.
 */
/* $Revision: 1.2 $
 * $Date: 2006/07/30 18:39:15 $
 * $Author: sid4u $
 */

#ifndef _BT_PEER_H_
#define _BT_PEER_H_

#include "lcore/tcp_socket.h"
//#include "bt_proto.h"
#include "bt_users.h"

// Peer cannot request more than 5 blocks when unchoked
#define MAX_PEER_BLOCK_REQUEST  5

typedef struct {
  tcp_socket_t _tcp_socket;
  bt_user_t* user;
  unsigned flags;
  unsigned features;
} bt_peer_t;

typedef const char* (*BtPeerConnected)(bt_peer_t* peer, object_t* obj);
const char* bt_peer_consume(bt_peer_t* peer);
bt_peer_t* bt_peer_new();
void bt_peer_connect_to_user(bt_torrent_t* torrent, ip_t ip, port_t port);
void bt_peer_request(bt_user_t* user, bt_torrent_t* torrent,
                     BtPeerConnected func, object_t* obj);

gboolean bt_peer_do_unchokes( bt_torrent_t* torrent );

#endif
