/* Copyright (C) 2005 The Lopster Team
 * This is free software distributed under the terms of the
 * GNU Public License.  See the file COPYING for details.
 */


/* $Revision: 1.4 $
 * $Date: 2007/09/24 20:46:59 $
 * $Author: sid4u $
 */

#ifndef _BT_TRACKER_H_
#define _BT_TRACKER_H_

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include "lcore/l_http.h"
#include "bt_torrent.h"

// TODO: Need to make some parameters dynamic
/*
		- numwant
		- add the SCRAP parameter and implement it (that would mean client can parse SCRAPPED results from tracker
		- .. more :)
*/

enum {
    BT_TRACKER_STOPPED=200020,
    BT_TRACKER_STARTED,
    BT_TRACKER_STOPPED_ERROR,
    BT_TRACKER_IS_MANNUALLY_STOPPING
};

typedef struct {
    object_t _object;
    /*char* protocol;
      char* url;
      int port; 
      char* request_path; */
    //TODO : need to discuss with Sgop regarding protocol from url_t , should make url_t to automatically call the right protocol ?
    url_t* url;
    bt_torrent_t* torrent;
    char* error_message;
    char* warning_message;
    int interval;
    int min_interval;
    char* id_old;
    char* id_new;
    int complete;
    int incomplete;
    GList* peers;
    gboolean state;
    gint pending_callback;
} bt_tracker_t;


module_t* bt_tracker_module_instance();

bt_tracker_t* bt_tracker_new_from_url(const char* url, gboolean allow_duplicates);

void bt_tracker_display_tracker(bt_tracker_t* tracker);
void bt_tracker_start_request(bt_tracker_t* tracker);
void bt_tracker_stop_request(bt_tracker_t* tracker);
void bt_tracker_stop_tracker_request(bt_tracker_t* tracker);


#endif //_BT_TRACKER_H_
