/* Copyright (C) 2005-2006 sgop@users.sourceforge.net.
 * This is free software distributed under the terms of the
 * GNU Public License.  See the file COPYING for details.
 */
/* $Revision: 1.3 $
 * $Date: 2007/09/21 09:41:54 $
 * $Author: sid4u $
 */

#include <string.h>
#include <stdlib.h>

#include "lcore/file_segment.h"
#include "bt_upload.h"
#include "bt_peer_protocol.h"


/*
    sid4u : this is not compilable yet..more a testing module, many things to do yet

*/

static GList* Uploads = NULL;
/*
#define HANDLER(f) static const char* f (bt_upload_t* upload, bt_peer_message_t* message)
#define BT_CALL(f) f(upload, command)
*/
static void bt_upload_queue(bt_upload_t* upload, int pos, int slots) {
    //FIXME
 //   if (!socket_connected(SOCK(upload))) return;
 //   dc_send(BSOCK(upload), FALSE, "$MaxedOut");
    // TODO : Check when this is called exactly to know if we can queue different requests here
}

static gboolean bt_upload_start(bt_upload_t* upload) {
    const char* res;
    if (!socket_connected(SOCK(upload))) return FALSE;

    // prepare segment now and start sending
    res = upload_prepare_segment(UPLOAD(upload));
    if (!res) return FALSE;
    return TRUE;
}

static gboolean bt_upload_end(bt_upload_t* upload, const char* message) {
    return upload_end(UPLOAD(upload), message);
}

static void bt_upload_list_init(bt_upload_list_t* uploads, bt_user_t* user ) {
    uploads->user = user;
}

static bt_upload_list_t* bt_upload_list_new( bt_user_t* user ) {
    bt_upload_list_t* uploads = g_malloc0(sizeof(*uploads));
    bt_upload_list_init(uploads, user);
    return uploads;
}

static void bt_upload_destroy(bt_upload_t* upload) {
    Uploads = g_list_remove(Uploads, upload);
    upload_destroy(UPLOAD(upload));
}

static void bt_upload_init(bt_upload_t* upload, bt_user_t* user, file_t* file) {
    upload_init(UPLOAD(upload), file, USER(user));
    object_add_type(OBJ(upload), "BtUpload");
    OBJ(upload)->destroy = (ObjectFunc)bt_upload_destroy;

   // FIXME: We dont end the socket, after block is sent check for more request and handle them
   //  socket_set_end(SOCK(upload), (SockEndFunc)bt_upload_end); 

    UPLOAD(upload)->queue = (UploadQueueFunc)bt_upload_queue;
    UPLOAD(upload)->start = (UploadStartFunc)bt_upload_start;
    Uploads = g_list_append(Uploads, upload);
}

bt_upload_t* bt_upload_new(bt_user_t* user, file_t* file)
{
    bt_upload_t* upload = g_malloc0(sizeof(*upload));
    bt_upload_init(upload, user, file);
    return upload;
}

bt_upload_list_t* bt_upload_update(bt_user_t* user, int index, int begin, int length) {
    GList* dlist;
    GList* files;
    bt_upload_t* upload;
    bt_upload_list_t* upload_list = NULL;
    
    gboolean multiple_files = FALSE; 
    
    file_size_t segment_length;
    file_size_t offset;
    file_size_t stop;

    segment_length = (file_size_t) length;

    for (dlist = Uploads; dlist; dlist = dlist->next)
    {
        upload_list = dlist->data;
        if (upload_list->user == user)
        {
            break;
        }
    }

    if (upload_list == NULL)
    {
        upload_list = bt_upload_list_new( user );
    }

    // Save these for later (sending the piece message) so don't need to recalculate them
    upload_list->index = index;
    upload_list->begin = begin;
    upload_list->length = length;

    // This is kind of tricky as we can have more than one files from index, begin and length
    files = bt_torrent_find_files_from_offsets(user->interested_torrent_me, index, begin, length);

    offset = bt_torrent_generate_offset_from_infos(user->interested_torrent_me, index, begin );
    stop = offset + segment_length ;

    // we may only have 1 files (if we're not talking about small files)
    if (g_list_length(files) > 1) 
        multiple_files= TRUE;

    for (; files ; files = files->next)
    {
        file_t* file = files->data;
        upload = bt_upload_new(user, file);
        upload_list->uploads = g_list_append(upload_list->uploads, upload);
        
        if (multiple_files == TRUE)
        {
            if (segment_length > file->size)
            {
                upload_add_segment(UPLOAD(upload), offset, file->size - offset , FALSE);

            }
            else
            {
                upload_add_segment(UPLOAD(upload), offset, file->size - segment_length , FALSE);
            }
            offset = 0;
            segment_length -= file->size;
        }
        else
        {
            upload_add_segment(UPLOAD(upload), offset, stop, FALSE);
        }
    }

    return upload_list;
}

// Sid : I wonder is this would work. I just send the header of the message , that normally,
// should be followed by the block itself.
// As the block can be separated in multiple files (cf. low file size like txt) 
// a list of upload was created and sent one after another.
// Will buffered socket upload one after another???
// Well this is implemented and not tested yet
static char* bt_upload_send_block_message(bt_upload_list_t* uploads, int index, int begin)
{
    GList* dlist;
    char* message;
    int transform;

    const char* res = upload_prepare_segment(UPLOAD(upload));
    segment_t* seg = UPLOAD(upload)->cur_segment;
    if (res) return res;
  
    message = g_malloc(sizeof(char*) * 13 + 1 );
//  memcpy(message,bt_peer_proto_create_message_header(((int)seg->stop - seg->start) + 13 ,7),5); 
    memcpy(message,bt_peer_proto_create_message_header(uploads->length + 9 ,7),5); 
    transform = htonl( uploads->index  );
    memcpy(message+5,&transform, 4);
    transform = htonl( uploads->begin  );
    memcpy(message+5+4,&transform, 4);
/*    transform = htonl( uploads->length  );
    memcpy(message+5+4+4,&transform, 4);
*/
    bt_send2(BSOCK(upload), 13 , message);   
    
    // Will fire away all queued upload one after the other in the uploads queue
    for (dlist = uploads->uploads; dlist ; dlist = dlist->next)
    {
        bt_upload_t* upload = dlist->data;
        b_socket_start_sending(BSOCK(upload));
    }
    return NULL;
}

const char* bt_upload_set_connection(bt_upload_t* upload, bt_peer_t* peer) {
    if (socket_connected(SOCK(upload))) return "upload already running";
  
    tcp_socket_move(TSOCK(upload), TSOCK(peer), TRUE); // FIXME : Should FALSE HERE ?

    // What we should do here is to handle back any other message coming back from peer 

//    upload_renew(UPLOAD(upload)); // What this ?????

    return "bt_peer->bt_upload";
}

#undef HANDLER
#undef BT_CALL
