/* Copyright (C) 2005 The Lopster Team This is free software
 * distributed under the terms of the GNU Public License.  See the
 * file COPYING for details.
 */
/* $Revision: 1.1 $
 * $Date: 2006/07/23 08:11:45 $
 * $Author: sid4u $
 */

#ifndef _BT_UPLOAD_H_
#define _BT_UPLOAD_H_

#include "lcore/upload.h"
#include "bt_peer.h"

#define BT_UPLOAD(arg) ((bt_upload_t*)(arg))

// List of uploads 
typedef struct {
  GList* uploads; // list of bt_upload_t 
  bt_user_t* user;
  int index;
  int begin;
  int length;
} bt_upload_list_t;

typedef struct {
  upload_t _upload;
} bt_upload_t;


bt_upload_t* bt_upload_new(bt_user_t* user, file_t* file);
void bt_upload_set_offset(bt_upload_t* upload, file_size_t offset, file_size_t stop);
const char* bt_upload_set_connection(bt_upload_t* upload, bt_peer_t* peer);
int bt_upload_get_total_queue(bt_upload_list_t* uploads);

#endif
