/* Copyright (C) 2005-2006 (sid4u@users.sourceforge.net) 
 * mostly inspired from (sgop@users.sourceforge.net) work on napster/directconnect plugin
 * This is free software distributed under the terms of the
 * GNU Public License.  See the file COPYING for details.
 */
/* $Revision: 1.3 $
 * $Date: 2006/07/30 18:39:15 $
 * $Author: sid4u $
 */

#ifndef _BT_USERS_
#define _BT_USERS_


#define BT_CLIENT_UNKNOWN		"Unknown_Client"


typedef struct _bt_user_t bt_user_t;

#include "lcore/user.h"
#include "bt_torrent.h"
#include "bt_bitfield.h"

#define BT_USER(arg) ((bt_user_t*)(arg))

enum {
    PEER_INCOMING,
    PEER_START,
    PEER_CONNECTING,
    PEER_CONNECTED,
    PEER_TRANSFERRING
};

typedef struct  {
    bt_torrent_t* torrent;
    bt_bitfield_t* user_bitfield;
} bt_user_torrent;

struct _bt_user_t {
    user_t _user;
    char* client;
    char* peer_id;
    rate_t* rate;
    gboolean ip_resolved;
    int state;
    gboolean seeder;
    gboolean is_snubbed;
    gboolean is_optimistic_unchoke;
    gboolean am_choking;
    gboolean am_interested;
    gboolean choking_me;
    gboolean interested_me;
    bt_user_torrent* am_interested_torrent;
    bt_torrent_t* interested_torrent_me;
};

module_t* bt_user_module_instance();

bt_user_t* bt_user_find(const char* peer_id);
void bt_user_setup(bt_user_t* user, const char* ip, int port);

void bt_user_set_am_interested_torrent(bt_user_t* user, bt_torrent_t* torrent);
bt_torrent_t*  bt_user_get_am_interested_torrent(bt_user_t* user);
bt_bitfield_t* bt_user_get_am_interested_torrent_bitfield(bt_user_t* user);
void bt_user_set_interested_torrent_bitfield(bt_user_t* user, bt_bitfield_t* user_torrent_bitfield);

#endif // _BT_USERS_
