/* Copyright (C) 2007   The Lopster Team
   This is free software distributed under the terms of the
   GNU Public License.  See the file COPYING for details. */

#ifndef _UI_DC_NET_HPP_
#define _UI_DC_NET_HPP_

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <QSortFilterProxyModel>

#include "bt.h"
#include "bt_torrent.h"
#include "bt_tracker.h"

#include "widgets/BtNetworkWidget.h"
#include "widgets/TorrentFileChooserDialog.h"


class BtNetModel;

/*
class BtSortFilterProxyModel : public QSortFilterProxyModel
{
Q_OBJECT 
public:
    BtSortFilterProxyModel(QObject *parent = 0);
};
*/

class UiBtNet : public QWidget, private Ui::BtNetworkWidget
{
    Q_OBJECT
public:
    UiBtNet(QWidget *parent=0);
    static UiBtNet *GetBtNet();   
    static void ui_bt_net_init();
    static void ui_bt_net_cleanup();

    static void ui_bt_torrent_hide(bt_torrent_t* torrent);
    static void ui_bt_torrent_update(bt_torrent_t* torrent);
    static void ui_bt_torrent_new(bt_torrent_t* torrent);

    static void ui_bt_tracker_show(bt_tracker_t* tracker);

    void ui_bt_create_torrent_win(bt_torrent_t* torrent);

private slots:
    void add_torrent();

private:
    BtNetModel *torrent_model;
};

class BtFileModel;
class TorrentFileChooserDialog : public QDialog, private Ui::TorrentFileChooserDialog
{
    Q_OBJECT
public:
    TorrentFileChooserDialog(bt_torrent_t* torrent, QWidget *parent=0);
private slots:
    void check_all_toggled(bool);
    void cancel_torrent();
    void validate_torrent();
private:
    bt_torrent_t* m_torrent;
    BtFileModel *file_model;
};
#endif
