/* Copyright (C) 2005-2007 sgop@users.sourceforge.net
 * This is free software distributed under the terms of the
 * GNU Public License.  See the file COPYING for details.
 */
/* $Revision: 1.3 $
 * $Date: 2007/05/23 20:42:28 $
 * $Author: sid4u $
 */

#ifndef _DC_CHAT_H_
#define _DC_CHAT_H_

#define DC_PAGE_OTHER    0
#define DC_PAGE_PRIVATE  1
#define DC_PAGE_PUBLIC   2

#include "lcore/chat.h"
#include "dc_network.h"

G_BEGIN_DECLS

typedef struct {
    chat_page_t _page;
    dc_hub_t* hub;
    int type;
    GList* users;
} dc_cp_t;
#define DCP(arg) ((dc_cp_t*)(arg))

dc_cp_t* dc_cp_new_private(dc_hub_t* hub, const char* nick);
dc_cp_t* dc_cp_new_public(dc_hub_t* hub);
void dc_server_message(dc_hub_t* hub, char* message);
void dc_private_message(dc_hub_t* hub, char* nick, char* message);
void dc_public_message(dc_hub_t* hub, char* nick, char* message);
void dc_motd_message(dc_hub_t* hub, char* message);
void dc_emote_message(dc_hub_t* hub, char* nick, char* message);

void dc_send_public_message(dc_cp_t* dcp, char* message);
void dc_send_private_message(dc_hub_t* hub, chat_page_t* page,
                             const char* nick, char *message);

dc_cp_t* dc_chat_active(dc_hub_t* hub);

G_END_DECLS
#endif
