/* Copyright (C) 2005 sgop@users.sourceforge.net
 * This is free software distributed under the terms of the
 * GNU Public License.  See the file COPYING for details.
 */
/* $Revision: 1.1 $
 * $Date: 2006/02/04 16:41:04 $
 * $Author: sgop $
 */

#ifndef _DC_PEER_H_
#define _DC_PEER_H_

#include "lcore/tcp_socket.h"
#include "dc_proto.h"
#include "dc_users.h"

#define S_PEER    S_TSOCK_LAST

#define DC_PEER_INCOMING  0x01
#define DC_PEER_DOWNLOAD  0x02

#define DC_FEATURE_BZLIST        0x01
#define DC_FEATURE_MINISLOTS     0x02
#define DC_FEATURE_XMLBZLIST     0x04
#define DC_FEATURE_GETZBLOCK     0x08


typedef struct {
  tcp_socket_t _tcp_socket;
  dc_user_t* user;
  unsigned flags;
  unsigned features;
} dc_peer_t;

typedef const char* (*DcPeerConnected)(dc_peer_t* peer, object_t* obj);

dc_peer_t* dc_peer_new();
void dc_peer_connect_to_user(dc_hub_t* hub, ip_t ip, port_t port);
void dc_peer_request(dc_user_t* user, dc_hub_t* hub,
                     DcPeerConnected func, object_t* obj);

#endif
