/* Copyright (C) 2005 sgop@users.sourceforge.net
 * This is free software distributed under the terms of the
 * GNU Public License.  See the file COPYING for details.
 */
/* $Revision: 1.1 $
 * $Date: 2006/02/04 16:41:04 $
 * $Author: sgop $
 */

#ifndef _DC_PROTO_H_
#define _DC_PROTO_H_

#include <string.h>

#include <glib.h>

#include "lcore/buffer.h"
#include "lcore/udp_socket.h"
#include "dc_network.h"

typedef struct {
  char* type;
  char* message;
  char* alloc;
  unsigned len;
} dc_message_t;

#define DC_REC(proto, level) \
  if (command->len > 90 && level != G_LOG_LEVEL_WARNING) {\
    char t = command->message[80];\
    command->message[80] = 0;\
    g_log(proto, level, "R: %s %s<%u remaining>", command->type?command->type:"-", command->message, command->len-80);\
    command->message[80] = t;\
  } else\
    g_log(proto, level, "R: %s %s", command->type?command->type:"-", command->message?command->message:"");

char* dc_unescape(char* text);
char* dc_escape(const char* text);

/* char* dc_str(const char* str); */
void dc_message_destroy(dc_message_t* message);
void dc_send(b_socket_t* sock, gboolean convert, const char* fmt, ...);
void dc_pack_command(buffer_t* buffer, const char* proto, const char* message);
dc_message_t* dc_consume_message(buffer_t* buffer);
dc_message_t* dc_consume_peer_message(buffer_t* buffer, ip_t* ip);

const char* dc_handle_message(dc_hub_t* hub, dc_message_t* command);
const char* dc_handle_udp_message(udp_socket_t* socket, dc_message_t* command, ip_t ip);

#endif
