/* Copyright (C) 2005-2007 sgop@users.sourceforge.net
 * This is free software distributed under the terms of the
 * GNU Public License.  See the file COPYING for details.
 */
/* $Revision: 1.3 $
 * $Date: 2007/04/29 09:28:12 $
 * $Author: sgop $
 */

#ifndef _DC_USERS_H_
#define _DC_USERS_H_

#include "lcore/user.h"
#include "dc_network.h"

typedef struct _dc_user_t dc_user_t;

#define DC_USER(arg) ((dc_user_t*)(arg))
struct _dc_user_t {
    user_t _user;

    char* linespeed;
    char* description;
    char* email;
    file_size_t bytes;
    GList* opped;
    GList* hubs;
};


module_t* dc_user_module_instance();


dc_user_t* dc_user_find(const char* nick);
void dc_user_left_hub(dc_hub_t* hub);

void dc_user_is_online(dc_user_t* user, dc_hub_t* hub);
void dc_user_is_offline(dc_user_t* user, dc_hub_t* hub);
void dc_user_set_bytes(dc_user_t* user, file_size_t bytes);


#endif
