/* Copyright (C) 2005-2007 sgop@users.sourceforge.net
 * This is free software distributed under the terms of the
 * GNU Public License.  See the file COPYING for details.
 */
/* $Revision: 1.5 $
 * $Date: 2007/09/05 14:34:10 $
 * $Author: sid4u $
 */

#include <stdarg.h>

#include <gtk/gtk.h>

#include "lcore/gtk2_ui/ui_layout.h"
#include "dc_ui.h"
#include "ui_dc_net.h"
#include "ui_dc_hotlist.h"
#include "ui_dc_chat.h"
#include "ui_dc_pref.h"
#include "ui_dc_search.h"

void ui_dc_create_page(dc_cp_t* page);

void ui_dc_init(ui_dc_t* iface)
{
    object_register_instance("DcHub", (ObjectFunc)ui_dc_hub_new, TRUE);
    object_register_instance("DcChatPage", (ObjectFunc)ui_dc_create_page, TRUE);
    object_register_instance("DcWebList", (ObjectFunc)ui_dc_weblist_new, TRUE);

    iface->hub_edit = ui_dc_hub_edit;
    iface->hub_set_status = ui_dc_hub_set_status;
    iface->user_appeared = ui_dc_user_appeared;
    iface->user_vanished = ui_dc_user_vanished;

    ui_layout_register_col("dc:hub:col:name");
    ui_layout_register_col("dc:hub:col:status");
    ui_layout_register_col("dc:hub:col:users");
    
    ui_layout_register_paned("dc:chat:paned:pos");
    ui_layout_register_vis("dc:chat:users:vis");
    ui_layout_register_col("dc:chat:col:user");
    ui_layout_register_col("dc:chat:col:shared");
    ui_layout_register_col("dc:chat:col:speed");
}

void ui_dc_run()
{
    ui_dc_net_init();
    ui_dc_hotlist_init();
    ui_dc_chat_init();
    ui_dc_pref_init();
    ui_dc_search_init();
}

void ui_dc_exit()
{

}

