/* Copyright (C) 2005-2007 sgop@users.sourceforge.net.
 * This is free software distributed under the terms of the
 * GNU Public License.  See the file COPYING for details.
 */
/* $Revision: 1.3 $
 * $Date: 2007/04/29 09:27:54 $
 * $Author: sgop $
 */

#include <gtk/gtk.h>

#include "lcore/l_i18n.h"
#include "lcore/gtk2_ui/ui_support.h"
#include "lcore/gtk2_ui/ui_preferences.h"
#include "lcore/gtk2_ui/ui_main.h"
#include "ui_dc_pref.h"
#include "dc_network.h"
#include "dc.h"

static GtkWidget* ui_general_user()
{
    GtkWidget* vbox;
    GtkWidget* hbox;
    GtkWidget* table;
    GtkWidget* item;
    
    vbox = ui_create_section
        (_("User settings"), 
         _("If you leave the user or password empty then the global default setting is used."),
         &hbox, NULL);

    table = gtk_table_new(1, 2, FALSE);
    gtk_box_pack_start(GTK_BOX(hbox), table, TRUE, TRUE, 0);
    gtk_table_set_col_spacings(GTK_TABLE(table), 5);
    
    item = ui_create_headed_item
        (_("username"), ui_pref_string_entry("/dc/username", _("Using default username")));
    gtk_table_attach(GTK_TABLE(table), item, 0, 1, 0, 1,
                     GTK_FILL|GTK_EXPAND,GTK_FILL|GTK_EXPAND,0,0);

    item = ui_create_headed_item
        (_("password"), ui_pref_string_entry("/dc/password", _("Using default password")));
    gtk_table_attach(GTK_TABLE(table), item, 1, 2, 0, 1,
                     GTK_FILL|GTK_EXPAND,GTK_FILL|GTK_EXPAND,0,0);
    
    gtk_widget_show_all(vbox);
    
    return vbox;
}

static GtkWidget* ui_general_port()
{
    GtkWidget* vbox;
    GtkWidget* hbox;
    GtkWidget* table;
    GtkWidget* item;
    
    vbox = ui_create_section(_("Port settings"), NULL, &hbox, NULL);

    table = gtk_table_new(1, 3, FALSE);
    gtk_box_pack_start(GTK_BOX(hbox), table, TRUE, TRUE, 0);
    gtk_table_set_col_spacings(GTK_TABLE(table), 5);
    
    item = ui_create_headed_item
        (_("tcp port"), ui_pref_int_spin("/dc/listen/tcp_port", 1, 65535));
    gtk_table_attach(GTK_TABLE(table), item, 0, 1, 0, 1,
                     GTK_FILL,GTK_FILL,0,0);
    
    item = ui_create_headed_item
        (_("udp port"), ui_pref_int_spin("/dc/listen/udp_port", 1, 65535));
    gtk_table_attach(GTK_TABLE(table), item, 1, 2, 0, 1,
                     GTK_FILL,GTK_FILL,0,0);
    
    gtk_widget_show_all(vbox);
    
    return vbox;
}

static GtkWidget* ui_general_misc()
{
    GtkWidget* vbox;
    GtkWidget* hbox;
    GtkWidget* item;

    vbox = ui_create_section(_("Miscellaneous settings"), NULL, &hbox, NULL);

    item = ui_pref_bool_check
        ("/dc/chat/autojoin", _("Automatically open public chat upon connect"), NULL, FALSE);
    gtk_box_pack_start(GTK_BOX(hbox), item, TRUE, TRUE, 0);

    gtk_widget_show_all(vbox);

    return vbox;
}


void ui_dc_pref_init()
{
    ui_pref_hook_plugin
        (DC_ID, ui_pref_register_leaf
         (    "DirectConnect", FALSE, _("Settings for the direct connect plugin"),
              ui_general_user,
              ui_general_port,
              ui_general_misc,
              NULL)
        );
}

