/* Copyright (C) 2005 sgop@users.sourceforge.net
   This is free software distributed under the terms of the
   GNU Public License.  See the file COPYING for details. */

#include <stdarg.h>
#include <string.h>

#include <gtk/gtk.h>

#include "lcore/gtk2_ui/ui_search.h"

static GtkEntry* HashEntry = NULL;

static GtkWidget* ui_search_option_create_hash() {
  GtkWidget* entry = gtk_entry_new();
  HashEntry = GTK_ENTRY(entry);
  return entry;
}
static int ui_search_option_get_hash(search_pattern_t* pattern) {
  const char* text;

  if (!pattern) return 1;
  text = gtk_entry_get_text(HashEntry);
  if (text && *text) {
    int i1;
    if (strlen(text) != 32) return 0;  //FIXME
    for (i1 = 0; i1 < 32; i1++) {
      if (!(text[i1] >= '0' && text[i1] <= '9') &&
	  !(text[i1] >= 'a' && text[i1] <= 'f') &&
	  !(text[i1] >= 'A' && text[i1] <= 'F')) return 0;
    }
    attr_store_str(ATTRC(pattern), "pattern", "urn:tree:tiger", text);
    return 1;
  } else {
    return 0;
  }
}
static int ui_search_option_set_hash(search_pattern_t* pattern) {
  attr_container_t* ac;
  attribute_t* attr;

  if (!pattern) return 1;
  ac = ATTRC(pattern);
  attr = attr_find(ac, "pattern", "urn:tree:tiger");
  if (attr) {
    gtk_entry_set_text(HashEntry, attr_xml_print(attr));
    return 1;
  } else {
    gtk_entry_set_text(HashEntry, "");
    return 0;
  }
}

void ui_dc_search_init() {

  ui_search_register_option("urn:tree:tiger", "Hash (DC)",
			    ui_search_option_create_hash,
			    ui_search_option_get_hash,
			    ui_search_option_set_hash);

}
