/* Copyright (C) 2005-2007 The Lopster Team
 * This is free software distributed under the terms of the
 * GNU Public License.  See the file COPYING for details.
 */
/* $Revision: 1.9 $
 * $Date: 2007/10/16 13:42:49 $
 * $Author: sid4u $
 */
#include "lcore/qt4_ui/ui_main.hpp"

#include "ui_dc_net.hpp"
#include "ui_dc_hotlist.hpp"
#include "ui_dc_chat.hpp"
#include "ui_dc_pref.hpp"
#include "ui_dc_search.hpp"
#include "ui_dc.hpp"

extern "C" QT4_DC_EXPORT void ui_dc_init(ui_dc_t* iface)
{
    initDirectConnnectResource();
    object_register_instance("DcHub", (ObjectFunc)UiDcNet::ui_dc_hub_new, TRUE);
    object_register_instance("DcChatPage", (ObjectFunc)UiDcChat::ui_dc_create_page, TRUE);
    object_register_instance("DcWebList", (ObjectFunc)UiDcNet::ui_dc_weblist_new, TRUE);

    iface->hub_edit = UiDcNet::ui_dc_hub_edit;
    iface->hub_set_status = UiDcNet::ui_dc_hub_set_status;
    iface->user_appeared = DcChatUserTree::ui_dc_user_appeared;
    iface->user_vanished = DcChatUserTree::ui_dc_user_vanished;
}

extern "C" QT4_DC_EXPORT void ui_dc_run()
{
    UiDcNet::ui_dc_net_init();
    UiDcHotlist::ui_dc_hotlist_init();
    UiDcPref::ui_dc_pref_init();
    UiDcSearch::ui_dc_search_init();
}

extern "C" QT4_DC_EXPORT void ui_dc_exit()
{
    UiDcNet::ui_dc_net_cleanup();
    UiDcHotlist::ui_dc_hotlist_cleanup();
    UiDcSearch::ui_dc_search_cleanup();
}

QIcon ui_dc_get_res_icon(const QString &res, const QSize &size, bool grey)
{
    QIcon orig;
    QIcon result;
    orig = QIcon(res);
    if (orig.isNull())
    {
        return orig;
    }
    
    QIcon::Mode mode = grey? (QIcon::Disabled) : (QIcon::Normal) ;
    result =  QIcon( orig ).pixmap(size, mode);
    return result;
}

