/* Copyright (C) 2007 Lopster Team. This is free software
 * distributed under the terms of the GNU Public License.  See the
 * file COPYING for details.
 */
/* $Revision: 1.1 $
 * $Date: 2007/10/16 13:42:49 $
 * $Author: sid4u $
 */

#ifndef _UI_DC_CHAT_H_
#define _UI_DC_CHAT_H_

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include "lcore/chat.h"
#include "lcore/preferences.h"
#include "lcore/string_list.h"
#include "lcore/lopster.h"
#include "lcore/l_i18n.h"
#include "dc_network.h"
#include "dc.h"
#include "dc_chat.h"

#include "ui_dc.hpp"

#include "lcore/qt4_ui/ui_treeview.hpp"
#include "lcore/qt4_ui/ui_chat.hpp"

class DcChatUserItemModel;
class DcChannelItemModel;

class DcChatUserTree : public UiTreeView
{
public:
    DcChatUserTree(QWidget *parent=0);
    void ui_dc_user_init(dc_cp_t* page);
    static void ui_dc_user_vanished(dc_cp_t* dcp, dc_user_t* user);
    static void ui_dc_user_update(dc_cp_t* dcp, dc_user_t* user);
    static void ui_dc_user_show(dc_cp_t* dcp, dc_user_t* user);
    static void ui_dc_user_appeared(dc_cp_t* dcp, dc_user_t* user);
};

#include "widgets/DcChatGuiBody.h"
class DcChatGui : public ChatGui
{
    Q_OBJECT
public:
    DcChatGui(dc_cp_t* page, QWidget *parent=0);
    DcChatUserTree *user_tree();
private:
    Ui::DcChatGuiBody body;
    dc_cp_t* m_page;
};

class UiDcChat : public QObject
{
    Q_OBJECT
public: 
    static void ui_dc_chat_init();
    static void ui_dc_create_page(dc_cp_t* page);
    static void ui_dc_public_remove(dc_cp_t* page);
};

#endif
