/* Copyright (C) 2007 The Lopster Team
 * This is free software
 * distributed under the terms of the GNU Public License.  See the
 * file COPYING for details.
 */
/* $Revision: 1.1 $
 * $Date: 2007/10/15 15:01:19 $
 * $Author: sid4u $
 */
#include "lcore/qt4_ui/ui_main.hpp"
#include "ui_dc.hpp"
#include "ui_dc_hotlist.hpp"


DcUserEditorWidget::DcUserEditorWidget(QWidget *parent) 
    : BasicUserEditorWidget(parent)
{ 
    group_plugin->setTitle(QString("direct connect"));
}

void DcUserEditorWidget::ui_buddy_user_populate(buddy_t *buddy)
{
    if (!buddy) return;

    attribute_t* attr = attr_find(ATTRC(buddy), "buddy", "DcNick");
    if (attr) {
        QString str = qfu(attr_get_ptr(attr, char));
        line_users->setText(str);
    }
}

void DcUserEditorWidget::ui_buddy_user_apply(buddy_t *buddy)
{
    QString nicks = line_users->text();
    if (!nicks.isEmpty()) {
        attr_store(ATTRC(buddy), "buddy", "DcNick", qtu(nicks));
    } else {
        attribute_t* attr = attr_find(ATTRC(buddy), "buddy", "DcNick");
        if (attr) attr_remove(ATTRC(buddy), attr);
    }
}

void DcUserFuncs::ui_buddy_plugin_user_update(user_t* user, UserItem *item)
{
    dc_user_t* dc_user = DC_USER(user);
    QMenu *menu;

    if (item->context)
        delete item->context;
    if (user->online)
    {
        item->setIcon(0, DICON(":/dc_icon.png", LOPSTER_TREEVIEW_ICON));
        DcHostlistActions *actions = new DcHostlistActions(dc_user);
        item->context = actions;
    }
    else {
        // Set Offline Icon
        item->setIcon(0, DICONG(":/dc_icon.png", LOPSTER_TREEVIEW_ICON));
        menu = new QMenu();
        QAction *action = menu->addAction(qtr("User is offline"));
        action->setEnabled(false);
        item->context = menu;
    }   
}

AbstractUserEditorWidget *DcUserFuncs::ui_buddy_plugin_edit_user()
{
    DcUserEditorWidget *editor = new DcUserEditorWidget();
    return editor;
}

DcHostlistActions::DcHostlistActions(dc_user_t* user)
    : QMenu()
{
    this->user = user;
    ui_create_chat_popup( );
    // ui_create_whois_popup( );
    ui_create_browse_popup( );
}

void DcHostlistActions::on_buddy_chat(QAction *action) {
    dc_hub_t* hub = hub_actions[action];
    if (hub && user)  dc_cp_new_private(hub, OBJ(user)->name);
}

void DcHostlistActions::ui_create_chat_popup() {
  GList* dlist;
  
  QMenu *chat = addMenu(qtr("Chat user on"));
  for (dlist = user->hubs; dlist; dlist = dlist->next) {
    dc_hub_t* hub = (dc_hub_t*) dlist->data;
    
    QAction *action = new QAction(qfu("<%1>").arg(OBJ(hub)->name), this);
    hub_actions[action] = hub;
    chat->addAction(action);
  }
  connect(chat, SIGNAL(triggered(QAction *)), this, SLOT(on_buddy_chat(QAction *)));
}

/*
void DcHostlistActions::on_buddy_whois(QAction *action) {
    dc_hub_t* hub = hub_actions[action];
    if (hub && user)
        dc_whois_user(user, hub, DC_WHOIS_WINDOW, FALSE);
}

void DcHostlistActions::ui_create_whois_popup() {
  GList* dlist;
  
  QMenu *whois = addMenu(qtr("Whois user on"));
  for (dlist = user->hubs; dlist; dlist = dlist->next) {
    dc_hub_t* hub = (dc_hub_t*) dlist->data;    
    QAction *action = new QAction(qfu("<%1>").arg(OBJ(hub)->name), this);
    hub_actions[action] = hub;
    whois->addAction(action);
  }
  connect(whois, SIGNAL(triggered(QAction *)), this, SLOT(on_buddy_whois(QAction *)));
}
*/


void DcHostlistActions::on_buddy_browse(QAction *action) {
    dc_hub_t* hub = hub_actions[action];
    if (user) dc_browse_user(user, hub);
}

void DcHostlistActions::ui_create_browse_popup() {
    GList* dlist;
    QMenu *browse = addMenu(qtr("Browse user on"));
    for (dlist = user->hubs; dlist; dlist = dlist->next) {
        dc_hub_t* hub = (dc_hub_t*) dlist->data;        
        QAction *action = new QAction(qfu("<%1>").arg(OBJ(hub)->name), this);
        hub_actions[action] = hub;
        browse->addAction(action);
    }
    connect(browse, SIGNAL(triggered(QAction *)), this, SLOT(on_buddy_browse(QAction *)));
}

void UiDcHotlist::ui_dc_hotlist_init() 
{
    DcUserFuncs *funcs = new DcUserFuncs();
    BuddiesPage::ui_buddy_register_funcs(DC_ID,funcs);
}

void UiDcHotlist::ui_dc_hotlist_cleanup()
{
}
