/* Copyright (C) 2007 The Lopster Team
   This is free software distributed under the terms of the
   GNU Public License.  See the file COPYING for details. */

#ifndef _UI_DC_HOTLIST_H_
#define _UI_DC_HOTLIST_H_

#include <QtGui>
#include "lcore/buddy.h"
#include "lcore/attribute.h"
#include "lcore/preferences.h"
#include "lcore/xml_handler.h"
#include "lcore/l_i18n.h"
#include "lcore/legacy.h"
#include "dc.h"
#include "dc_hotlist.h"
#include "dc_chat.h"
#include "dc_users.h"
#include "dc_browse.h"

#include "lcore/qt4_ui/ui_buddies.hpp"


class DcUserEditorWidget : public BasicUserEditorWidget
{
public:
    DcUserEditorWidget(QWidget *parent=0);
    void ui_buddy_user_populate(buddy_t *buddy);
    void ui_buddy_user_apply(buddy_t *buddy);
};

class DcUserFuncs : public BuddyFuncs
{
public:
    void ui_buddy_plugin_user_update(user_t* user, UserItem *item);
    AbstractUserEditorWidget *ui_buddy_plugin_edit_user();
};

class DcHostlistActions : public QMenu
{
    Q_OBJECT   
public:
    DcHostlistActions(dc_user_t* user);
    void ui_create_chat_popup( );
   // void ui_create_whois_popup( );
    void ui_create_browse_popup( );
    QMenu *ui_return_user_menu( ) {return main_popup;}
private slots:
    void on_buddy_browse(QAction *action);
  //  void on_buddy_whois(QAction *action);
    void on_buddy_chat(QAction *action);
private:
    QMenu* main_popup;
    dc_user_t* user;
    QHash <QAction *, dc_hub_t*> hub_actions;
};


class UiDcHotlist : public QObject
{
    Q_OBJECT
 public:
    static void ui_dc_hotlist_init();
    static void ui_dc_hotlist_cleanup();
};

#endif
