/* Copyright (C) 2007 The Lopster team
   This is free software distributed under the terms of the
   GNU Public License.  See the file COPYING for details. */


/* $Revision: 1.3 $
 * $Date: 2007/11/13 14:04:11 $
 * $Author: sid4u $
 */


#include "lcore/l_i18n.h"
#include "dc_network.h"
#include "dc.h"

#include "lcore/qt4_ui/ui_preferences.hpp"
#include "lcore/qt4_ui/ui_main.hpp"
#include "ui_dc_pref.hpp"



UiDcPref::UiDcPref(QWidget *parent)
        :QWidget(parent)
{
    setupUi(this);
}

UiDcPref::~UiDcPref( )
{
}

UiDcPref *UiDcPref::ui_dc_pref_create() {
    UiDcPref *dc_pref = new UiDcPref();
	dc_pref->setObjectName("UiDcPref");
    LineEditPrefUpdater *dc_login =    
                new LineEditPrefUpdater("/dc/username", dc_pref->line_username);
    LineEditPrefUpdater *dc_pass =     
                new LineEditPrefUpdater("/dc/password", dc_pref->line_password);
    SpinBoxPrefUpdater *dc_tcp_port =  
                new SpinBoxPrefUpdater("/dc/listen/tcp_port", dc_pref->spin_tcp);
    SpinBoxPrefUpdater *dc_ucp_port =  
                new SpinBoxPrefUpdater("/dc/listen/udp_port", dc_pref->spin_udp);
    
    //TODO : add the checkbox pref handler to the main core preference
    CheckBoxPrefUpdater *dc_auto_pub =  
                new CheckBoxPrefUpdater("/dc/chat/autojoin", dc_pref->check_auto_pub);


    PreferencesDialog::ui_preferences_apply_cancel_add(dc_login);
    PreferencesDialog::ui_preferences_apply_cancel_add(dc_pass);
    PreferencesDialog::ui_preferences_apply_cancel_add(dc_tcp_port);
    PreferencesDialog::ui_preferences_apply_cancel_add(dc_ucp_port);
    PreferencesDialog::ui_preferences_apply_cancel_add(dc_auto_pub);
    return dc_pref;
}

void UiDcPref::ui_dc_pref_init() {
    PreferencesDialog::ui_preferences_plugin_add_page(DC_ID, "DirectConnect",
            qtr("Settings for the directconnect network plugin"), 
				(CreatePrefPageFunc) ui_dc_pref_create);
}
