/* Copyright (C) 2005 sgop@users.sourceforge.net This is free software
 * distributed under the terms of the GNU Public License.  See the
 * file COPYING for details.
 */
/* $Revision: 1.1 $
 * $Date: 2007/10/15 14:06:39 $
 * $Author: sid4u $
 */

#include <stdarg.h>

#include <QComboBox>

#include "lcore/l_i18n.h"
#include "lcore/lopster.h"
#include "dc_network.h"
#include "dc.h"

#include "lcore/qt4_ui/ui_main.hpp"
#include "lcore/qt4_ui/ui_utils.hpp"
#include "ui_dc_search.hpp"
#include "widgets/DcSearchParameterWidget.h"

UiDcSearchOption::UiDcSearchOption(QObject* parent)
    : SearchOption(parent)
{
    widget = new QWidget; 
    Ui::DcSearchParameterWidget dc_search_parameters;
    dc_search_parameters.setupUi(widget);
    hash = dc_search_parameters.line_hash;
}

UiDcSearchOption::~UiDcSearchOption() 
{

}

int UiDcSearchOption::search_option_set_value(search_pattern_t* pattern)
{
    attr_container_t* ac;
    attribute_t* attr;

    if (!pattern) return 1;
    ac = ATTRC(pattern);
    attr = attr_find(ac, "pattern", "urn:tree:tiger");
    if (attr) {
        hash->setText(qfu(attr_xml_print(attr)));
        return 1;
    } else {
        hash->setText("");
        return 0;
    }
}

int UiDcSearchOption::search_option_get_value(search_pattern_t* pattern)
{
    const char* text;

    if (!pattern) return 1;
    text = qtu(hash->text());
    if (text && *text) {
        int i1;
        if (strlen(text) != 32) return 0;  //FIXME
        for (i1 = 0; i1 < 32; i1++) {
            if (!(text[i1] >= '0' && text[i1] <= '9') &&
                !(text[i1] >= 'a' && text[i1] <= 'f') &&
                !(text[i1] >= 'A' && text[i1] <= 'F')) return 0;
        }
        attr_store_str(ATTRC(pattern), "pattern", "urn:tree:tiger", text);
        return 1;
    } else {
        return 0;
    }
}

void UiDcSearch::ui_dc_search_init() {
    UiDcSearchOption *option = new UiDcSearchOption();
    SearchPage::s_ui_search_register_option(option, DC_ID);
}

void UiDcSearch::ui_dc_search_cleanup() {
}
