/* Copyright (C) 2005-2006 sgop@users.sourceforge.net
 * This is free software distributed under the terms of the
 * GNU Public License.  See the file COPYING for details.
 */
/* $Revision: 1.7 $
 * $Date: 2007/11/21 20:19:38 $
 * $Author: sgop $
 */

#include <stdarg.h>

#include <gtk/gtk.h>

#include "lcore/gtk2_ui/ui_layout.h"
#include "lcore/gtk2_ui/ui_style.h"
#include "lcore/gtk2_ui/ui_main.h"
#include "ui_nap_net.h"
#include "ui_nap_chat.h"
#include "ui_nap_search.h"
#include "ui_nap_hotlist.h"
#include "ui_nap_pref.h"
#include "ui_nap_whois.h"
#include "nap.h"
#include "nap_ui.h"
#ifdef WIN32
#include "gtk2napalias.h"
#endif

void ui_nap_init(ui_nap_t* iface)
{
    object_register_instance("NapServer", (ObjectFunc)ui_nap_server_new, TRUE);
    object_register_instance("NapNetwork", (ObjectFunc)ui_nap_net_new, TRUE);
    object_register_instance("NapGroup", (ObjectFunc)ui_nap_ng_new, TRUE);
    object_register_instance("NapChannels", (ObjectFunc)ui_nap_channel_list_new, TRUE);
    object_register_instance("NapPublicPage", (ObjectFunc)ui_nap_create_public_page, TRUE);
    object_register_instance("NapChannelUser", (ObjectFunc)ui_nap_user_new, TRUE);
    object_register_instance("NapServerService", (ObjectFunc)ui_nap_service_new, TRUE);

    iface->channel_joined = ui_nap_channel_joined;
    iface->cp_update_op = ui_nap_cp_update_op;
    iface->new_topic = ui_nap_new_topic;
    iface->user_joined = ui_nap_user_joined;
    iface->user_parted = ui_nap_user_parted;
    iface->whois_show = ui_nap_whois_show;


    // layout for columns of network list
    ui_layout_register_col("nap:net:col:name");
    ui_layout_register_col("nap:net:col:status");
    ui_layout_register_col("nap:net:col:fails");
    ui_layout_register_col("nap:net:col:speed");
    ui_layout_register_col("nap:net:col:users");
    ui_layout_register_col("nap:net:col:files");
    ui_layout_register_col("nap:net:col:gigs");
    
    // paned position in chat page
    ui_layout_register_paned("nap:chat:paned:pos");
    ui_layout_register_paned("nap:chat:op:paned:pos");
    // layout for columns in channel user list
    ui_layout_register_vis("nap:chat:users:vis");
    ui_layout_register_vis("nap:chat:chop:vis");
    ui_layout_register_col("nap:chat:col:user");
    ui_layout_register_col("nap:chat:col:shared");
    ui_layout_register_col("nap:chat:col:speed");
    
    // layout for columns in channel list
    ui_layout_register_col("nap:chan:col:name");
    ui_layout_register_col("nap:chan:col:online");
    ui_layout_register_col("nap:chan:col:limit");
    ui_layout_register_col("nap:chan:col:level");
    ui_layout_register_col("nap:chan:col:topic");
    
}

void ui_nap_run()
{
    ui_nap_net_init();
    ui_nap_chat_init();
    ui_nap_search_init();
    ui_nap_hotlist_init();
    ui_nap_pref_init();
}

void ui_nap_exit()
{
    // dummy function to support other ui exit function
}

#ifdef WIN32
#define _UI_NAP_C_
#include "gtk2napaliasdef.c"
#endif
