/* Copyright (C) 2005 sgop@users.sourceforge.net This is free software
 * distributed under the terms of the GNU Public License.  See the
 * file COPYING for details.
 */
/* $Revision: 1.3 $
 * $Date: 2006/07/22 17:14:04 $
 * $Author: sid4u $
 */

#include <stdarg.h>

#include <gtk/gtk.h>

#include "lcore/l_i18n.h"
#include "lcore/lopster.h"
#include "lcore/gtk2_ui/ui_search.h"
#include "nap_network.h"

static GtkComboBox* LineMin = NULL;
static GtkComboBox* LineMax = NULL;

static GtkWidget* ui_search_option_create_speed() {
  GtkWidget* label;
  GtkWidget* hbox;
  GtkWidget* combo;
  int i1;
  GtkRequisition req;
  
  hbox = gtk_hbox_new (FALSE, 5);
  //  gtk_widget_show (hbox);

  combo = gtk_combo_box_new_text();
  gtk_widget_show(combo);
  for (i1 = 0; i1 <= 10; i1++) {
    gtk_combo_box_append_text(GTK_COMBO_BOX(combo), _(NapSpeedStrShort(i1)));
  }
  gtk_combo_box_set_active(GTK_COMBO_BOX(combo), 0);
  gtk_widget_set_size_request(combo, 0, -1);
  gtk_box_pack_start(GTK_BOX(hbox), combo, TRUE, TRUE, 0);
  LineMin = GTK_COMBO_BOX(combo);
  gtk_widget_size_request(combo, &req);
  gtk_widget_set_size_request(combo, 0, req.height-6);
  ui_search_input_monitor(combo);

  label = gtk_label_new(_("to"));
  gtk_widget_show(label);
  gtk_box_pack_start(GTK_BOX(hbox), label, FALSE, TRUE, 0);

  combo = gtk_combo_box_new_text();
  gtk_widget_show(combo);
  for (i1 = 0; i1 <= 10; i1++) {
    gtk_combo_box_append_text(GTK_COMBO_BOX(combo), _(NapSpeedStrShort(i1)));
  }
  gtk_combo_box_set_active(GTK_COMBO_BOX(combo), 0);
  gtk_widget_set_size_request(combo, 0, -1);
  gtk_box_pack_start(GTK_BOX(hbox), combo, TRUE, TRUE, 0);
  LineMax = GTK_COMBO_BOX(combo);
  gtk_widget_set_size_request(combo, 0, req.height-6);
  ui_search_input_monitor(combo);

  return hbox;
}
static int
ui_search_option_set_speed(search_pattern_t* pattern) {
  attr_container_t* ac;
  attribute_t* attr;

  if (!pattern) return 1;
  ac = ATTRC(pattern);
  attr = attr_find(ac, "pattern", "NapSpeed");
  if (attr) {
    gtk_combo_box_set_active(LineMin, ((int*)(attr->value))[0]);
    gtk_combo_box_set_active(LineMax, ((int*)(attr->value))[1]);
    return 1;
  } else {
    gtk_combo_box_set_active(LineMin, 0);
    gtk_combo_box_set_active(LineMax, 0);
    return 0;
  }
}
static int
ui_search_option_get_speed(search_pattern_t* pattern) {
  int min, max;
  
  if (!pattern) return 1; 
  min = gtk_combo_box_get_active(LineMin);
  max = gtk_combo_box_get_active(LineMax);

  if (min < 0) min = 0;
  if (max < 0) max = 0;

  if (min || max) {
    attr_store(ATTRC(pattern), "pattern", "NapSpeed", min, max);
    return 1;
  } else {
    return 0;
  }
}

void ui_nap_search_init() {

  ui_search_register_option("NapSpeed", N_("Linespeed (NAP)"),
                            ui_search_option_create_speed,
                            ui_search_option_get_speed,
                            ui_search_option_set_speed);

}
