/* Copyright (C) 2005 sgop@users.sourceforge.net This is free software
 * distributed under the terms of the GNU Public License.  See the
 * file COPYING for details.
 */
/* $Revision: 1.3 $
 * $Date: 2006/07/22 17:14:03 $
 * $Author: sid4u $
 */

#ifndef _NAP_BROWSE_H_
#define _NAP_BROWSE_H_

#include "lcore/tcp_socket.h"
#include "lcore/browse.h"
#include "nap_network.h"



#define NAP_BROWSE(arg) ((nap_browse_t*)(arg))
typedef struct _nap_browse_t nap_browse_t;

#define S_BROWSE_COMPLETE  200
#define S_NOT_SHARING      201
#define S_BROWSE_FAILED    202

G_BEGIN_DECLS

void nap_browse_user(nap_user_t* user);
void nap_browse_finished(nap_user_t* user, nap_browse_t* browse);
void nap_browse_error(nap_user_t* user, const char* message);
void nap_browse_insert_file(nap_browse_t* browse, file_t* file);

/* outgoing connection, get list */
void nap_browse_outgoing_get(nap_user_t* user, ip_t ip, port_t port);
/* incoming connection, get list */
const char* nap_browse_incoming_get(tcp_socket_t* s);

/* outgoing connection, send list */
void nap_browse_outgoing_send(nap_net_t* net, ip_t ip, port_t port);
/* incoming connection, send list */
const char* nap_browse_incoming_send(tcp_socket_t* s);

void nap_browse_set_last_net(nap_net_t* net);

G_END_DECLS

#endif
