/* Copyright (C) 2005 sgop@users.sourceforge.net
   This is free software distributed under the terms of the
   GNU Public License.  See the file COPYING for details. */

#ifndef _NAP_PROTO_H_
#define _NAP_PROTO_H_

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include "lcore/b_socket.h"
#include "nap_network.h"

#define NAP_S_LOGIN                    2
#define NAP_S_SHARE_FILE             100
#define NAP_S_UNSHARE_FILE           102
#define NAP_S_UNSHARE_ALL            110
#define NAP_S_SEARCH                 200
#define NAP_S_DOWNLOAD_REQUEST       203
#define NAP_S_PRIVATE_MSG            205
#define NAP_S_HOT_ADD                207
#define NAP_S_HOT_ADD_SEQ            208
#define NAP_S_BROWSE                 211
#define NAP_S_DOWNLOAD_STARTED       218
#define NAP_S_DOWNLOAD_STOPPED       219
#define NAP_S_UPLOAD_STARTED         220
#define NAP_S_UPLOAD_STOPPED         221
#define NAP_S_HOT_REMOVE             303
#define NAP_S_JOIN_CHANNEL           400
#define NAP_S_PART_CHANNEL           401
#define NAP_S_PUBLIC_MSG             402
#define NAP_S_SET_TOPIC              410
#define NAP_S_CH_BAN                 422
#define NAP_S_CH_UNBAN               423
#define NAP_S_DOWNLOAD_FW            500
#define NAP_S_WHOIS                  603
#define NAP_S_ACCEPT_UPLOAD          608
#define NAP_S_KILL                   610
#define NAP_S_NUKE                   611
#define NAP_S_BAN                    612
#define NAP_S_UNBAN                  614
#define NAP_S_QUEUE_UPLOAD           619
#define NAP_S_MUZZLE                 622
#define NAP_S_UNMUZZLE               623
//#define NAP_S_ALTER_SPEED            625
#define NAP_S_WALLOP_MSG             627
#define NAP_S_GLOBAL_MSG             628
#define NAP_S_BROWSE_DIRECT          640
#define NAP_S_BROWSE_DIRECT_OK       641
#define NAP_S_SPEED                  700
#define NAP_S_PASSWORD               701
#define NAP_S_PING                   751
#define NAP_S_PONG                   752
#define NAP_S_ALTER_PASSWORD         753
#define NAP_S_CHANGE_PORT            703
#define NAP_S_SET_CHLEVEL            823
#define NAP_S_GET_CHLEVEL            823
#define NAP_S_EMOTE_MSG              824
#define NAP_S_SET_CHLIMIT            826
#define NAP_S_GET_CHLIMIT            826
#define NAP_S_GET_CHANNELS           827
#define NAP_S_GET_GUSER              831
#define NAP_S_GET_USAGE_STATS      10115
#define NAP_S_SET_USERMODE         10203
#define NAP_S_CH_OP                10204
#define NAP_S_CH_DEOP              10205
#define NAP_S_CHOP_MSG             10208
#define NAP_S_SET_CHMODE           10209
#define NAP_S_GET_CHMODE           10209
#define NAP_S_CH_INVITE            10210
#define NAP_S_CH_VOICE             10211
#define NAP_S_CH_DEVOICE           10212
#define NAP_S_CH_MUZZLE            10213
#define NAP_S_CH_UNMUZZLE          10214
#define NAP_S_SHARE_GENERIC        10300

/* not needed
  214,      //    request server stats (short)
  410,      //    get channel topic
  600,      //    get user speed
  621,      //    get MOTD
  801,      //    get server version
  10250,    //    class add
  10251,    //100 class remove
  10252,    //    class list
  10253,    //    dline add
  10254,    //    dline remove
  10255,    //    dline list
  10256,    //105 iline add
  10257,    //    iline remove
  10258,    //    iline list
  10259,    //    eline add
  10260,    //    eline remove
  10261,    //110 eline list
*/
/*
  420,      //    get channel ban list
  606,      // 30 set user level
  613,      // 35 change user's upload port
  615,      //    get global ban list
  652,      //    cloak
  702,      // 50 change email
  750,      //    ping server
  820,      //    clear channel
  624,      // 60 unnuke user
  10117,    //    reload server config
  810,      //    get server vars
  810,      //    get server var
  810,      //    set server var
  821,      // 65 redirect user
  822,      //    cycle user
  829,      //    kick user from channel
  830,      //    get channel user list
  10100,    //    link server
  10101,    // 75 delink server
  10111,    //    remove server
  10110,    //    shutdown server
  10112,    //    get server links
  10118,    // 80 get client version stats
  10119,    //    locate user
  10121,    //    whowas user
  10122,    //    masskill ip
  10123,    //    server incoming command histogram
  10125,    // 85 server outgoing command histogram
  10200,    //    register user
  10203,    //    get user mode
  10213,    //    list muzzle in channel
  800,      //    reset server var to default
  10204,    //    list ops in channel
  10211,    //    list voice in channel
  0,        //115 change nick
  116,      //    raw command // dummy command id
  0,        //    private emote message
*/

typedef struct {
  guint16 len;
  guint16 type;
  char* message;
} nap_message_t;

void nap_pack_command(buffer_t* buffer, guint16 type, const char* message);
nap_message_t* nap_consume_message(buffer_t* buffer);
const char* nap_handle_message(nap_net_t* net, nap_message_t* command);

#endif
