/* Copyright (C) 2005 (sgop@users.sourceforge.net)
   This is free software distributed under the terms of the
   GNU Public License.  See the file COPYING for details. */

#ifndef _NAP_USERS_
#define _NAP_USERS_

#define NAP_CLIENT_UNKNOWN      0
#define NAP_CLIENT_WINMX_26     1
#define NAP_CLIENT_LOPSTER_ADV  2

typedef struct _nap_user_t nap_user_t;

#include "lcore/search.h"
#include "lcore/module.h"
#include "nap_network.h"

#define NAP_USER(arg) ((nap_user_t*)(arg))
struct _nap_user_t {
  user_t _user;
  nap_net_t* net;

  int speed;
  int shared;
  char* client;
  int client_id;
  void* whois;  //make a list for the networks?
  GList* nets;
};

G_BEGIN_DECLS

module_t* nap_user_module_instance();


//void nap_user_set_net(nap_user_t* user, nap_net_t* net);
nap_user_t* nap_user_find(const char* nick, nap_net_t* net);
void nap_user_setup(nap_user_t* user, ip_t ip, int speed);
void nap_user_set_net(nap_user_t* user, nap_net_t* net);

void nap_user_set_client(nap_user_t* user, const char* client);

void nap_user_muzzle  (nap_user_t* user, nap_net_t* net, const char* reason);
void nap_user_unmuzzle(nap_user_t* user, nap_net_t* net, const char* reason);
void nap_user_kill    (nap_user_t* user, nap_net_t* net, const char* reason);
void nap_user_ban     (nap_user_t* user, nap_net_t* net, const char* reason, unsigned timeout);
void nap_user_unban   (nap_user_t* user, nap_net_t* net, const char* reason);
void nap_user_nuke    (nap_user_t* user, nap_net_t* net);

G_END_DECLS

#endif
