/* Copyright (C) 2004 sgop@users.sourceforge.net
   This is free software distributed under the terms of the
   GNU Public License.  See the file COPYING for details. */

#ifndef _NAP_WHOIS_H_
#define _NAP_WHOIS_H_

#include <glib.h>

#include "nap_network.h"

#define NAP_WHOIS_TEXT       0x01
#define NAP_WHOIS_WINDOW     0x02
#define NAP_WHOIS_QUIET      0x04

#define NAP_WHOIS_UNKNOWN       0
#define NAP_WHOIS_TIMEOUT       1
#define NAP_WHOIS_OFFLINE       2
#define NAP_WHOIS_ONLINE        3

#define NS_WHOIS    0
#define NS_DOWN     1
#define NS_R_0      2
#define NS_R_10000  3
#define NS_N_QUEUE  4
#define NS_UP       5
#define NS_NUM      6

#define NAP_WHOIS(arg) ((nap_whois_t*)(arg))
typedef struct {
  nap_net_t* net;
  int mode;
  int timer;
  int status;//
  time_t online;//
  time_t refreshed;

  char* str_level;//
  int level;//
  char* channel;//
  char* stat;//
  int dl, ul;//
  int tdl, tul;//
  port_t server_port;
  char* email;
  char* server;
} nap_whois_t;

G_BEGIN_DECLS

nap_whois_t* nap_whois_user(nap_user_t* user, nap_net_t* net,
			    int mode, gboolean force);
void nap_whois_received(nap_user_t* user);

void nap_user_stat_cnt(nap_user_t* user, unsigned sec);
void nap_user_stat_print();

G_END_DECLS

#endif
