/* Copyright (C) 2005-2006 The Lopster Team
 * This is free software distributed under the terms of the
 * GNU Public License.  See the file COPYING for details.
 */
/* $Revision: 1.13 $
 * $Date: 2007/09/11 07:36:25 $
 * $Author: sid4u $
 */
#include <QIcon>

#include "nap.h"
#include "nap_ui.h"

#include "lcore/qt4_ui/ui_main.hpp"
#include "ui_nap_net.hpp"
#include "ui_nap_net.hpp"
#include "ui_nap_search.hpp"
#include "ui_nap_hotlist.hpp"
#include "ui_nap_chat.hpp"
#include "ui_nap_whois.hpp"
#include "ui_nap_pref.hpp"
#include "ui_nap.hpp"

extern "C" QT4_NAP_EXPORT void ui_nap_init(ui_nap_t* iface)
{
	initNapsterResource();
    object_register_instance("NapServer", (ObjectFunc)UiNapNetwork::ui_nap_server_new, TRUE);
    object_register_instance("NapNetwork", (ObjectFunc)UiNapNetwork::ui_nap_net_new, TRUE);
    object_register_instance("NapGroup", (ObjectFunc) UiNapNetwork::ui_nap_ng_new, TRUE);
    object_register_instance("NapChannels", (ObjectFunc)ChannelsListDlg::ui_nap_channel_list_new, TRUE);   
    object_register_instance("NapPublicPage", (ObjectFunc)UiNapChat::ui_nap_create_public_page, TRUE);
    object_register_instance("NapChannelUser", (ObjectFunc)NapChatUserTree::ui_nap_user_new, TRUE);
    object_register_instance("NapServerSerivce", (ObjectFunc)UiNapNetwork::ui_nap_service_new, TRUE);

    iface->new_topic        =   UiNapChat::ui_nap_new_topic;
    iface->user_joined      =   UiNapChat::ui_nap_user_joined;
    iface->user_parted      =   UiNapChat::ui_nap_user_parted;
    iface->channel_joined   =   UiNapChat::ui_nap_channel_joined;
    iface->cp_update_op     =   UiNapChat::ui_nap_cp_update_op;
    iface->whois_show       =   UiNapWhois::ui_nap_whois_show;
}

extern "C" QT4_NAP_EXPORT void ui_nap_run()
{
    UiNapNetwork::ui_nap_net_init();
    UiNapSearch::ui_nap_search_init();
    UiNapChat::ui_nap_chat_init();
    UiNapHotlist::ui_nap_hotlist_init();
    UiNapPref::ui_nap_pref_init();
}

extern "C" QT4_NAP_EXPORT void ui_nap_exit()
{
    UiNapNetwork::ui_nap_net_cleanup();
    UiNapSearch::ui_nap_search_cleanup();
    UiNapHotlist::ui_nap_hotlist_cleanup();
  /*  ;
    UiNapChat::ui_nap_chat_cleanup();
    UiNapPref::ui_nap_pref_cleanup();*/
}


QIcon ui_nap_get_res_icon(const QString &res, const QSize &size, bool grey)
{
    QIcon orig;
    QIcon result;
    orig = QIcon(res);
    if (orig.isNull())
    {
        return orig;
    }
    
    QIcon::Mode mode = grey? (QIcon::Disabled) : (QIcon::Normal) ;
    result =  QIcon( orig ).pixmap(size, mode);
    return result;
}
