/* Copyright (C) 2007 Lopster Team. This is free software
 * distributed under the terms of the GNU Public License.  See the
 * file COPYING for details.
 */
/* $Revision: 1.2 $
 * $Date: 2007/10/11 12:01:59 $
 * $Author: sid4u $
 */

#ifndef _UI_NAP_CHAT_H_
#define _UI_NAP_CHAT_H_

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include "lcore/chat.h"
#include "lcore/preferences.h"
#include "lcore/string_list.h"
#include "lcore/lopster.h"
#include "lcore/l_i18n.h"
#include "nap_network.h"
#include "nap.h"
#include "nap_chat.h"

#include "ui_nap.hpp"

#include "lcore/qt4_ui/ui_treeview.hpp"
#include "lcore/qt4_ui/ui_chat.hpp"

#include "widgets/ChannelsListDlg.h"

class NapChatUserItemModel;
class NapChannelItemModel;

class NapChatUserTree : public UiTreeView
{
public:
    NapChatUserTree(QWidget *parent=0);
    void ui_nap_user_init(nap_pub_t* page);
    static void ui_nap_user_new(nap_cu_t* cu, nap_pub_t* npp);
    static void ui_nap_user_show(nap_cu_t* cu, nap_pub_t* npp);
    static void ui_nap_user_update(nap_cu_t* cu, nap_pub_t* npp);
    static void ui_nap_user_hide(nap_cu_t* cu, nap_pub_t* npp);
};

#include "widgets/NapChatGuiBody.h"
class NapChatGui : public ChatGui
{
    Q_OBJECT
public:
    NapChatGui(nap_pub_t* page, QWidget *parent=0);
    void            ui_nap_chat_gui_update_topic(const QString &title);
    NapChatUserTree *user_tree();
    QLabel          *label_counter();
    QWidget         *ui_nap_chat_get_op_tools();
    QLineEdit       *ui_nap_chat_get_op_limit();
    QComboBox       *ui_nap_chat_get_op_level();
    static void     ui_nap_chat_print_net(QTextCursor cursor, va_list ap);
    static void     ui_nap_chat_print_netstr(QTextCursor cursor, va_list ap);
    static void     ui_nap_chat_print_channel(QTextCursor cursor, va_list ap);
    QToolButton *mbutton[NAP_CMODE_NUMBER];
private:
    void on_chmode_clicked(bool checked, int mode);
    Ui::NapChatGuiBody body;
    nap_pub_t* m_page;
private slots:
    void ui_nap_chat_toggle_ctrl();
    void ui_nap_chat_toggle_op();
    void ui_nap_chat_toggle_users();
    void on_chmode_t_clicked(bool);
    void on_chmode_r_clicked(bool);
    void on_chmode_p_clicked(bool);
    void on_chmode_i_clicked(bool);
    void on_chmode_m_clicked(bool);
    void on_chlevel_changed(int);
    void on_chlimit_clicked();
};

class ChannelsListDlg : public QDialog, private Ui::ChannelsListDlg
{
  Q_OBJECT
public:
    ChannelsListDlg(nap_channels_t* channel,  QWidget *parent = 0);
    ~ChannelsListDlg();
    static void ui_nap_channels_destroy(nap_channels_t* channels);
    static void ui_nap_channels_update(nap_channels_t* channels);
    static void ui_nap_channel_list_new(nap_channels_t* channels);
    NapChannelItemModel *model_channel;
    nap_channels_t* chans;
};

class UiNapChat : public QObject
{
    Q_OBJECT
public: 
    static void ui_nap_chat_init();
    static void ui_nap_public_remove(chat_page_t* page);
    static void ui_nap_create_public_page(nap_pub_t* page);
    static void ui_nap_new_topic(nap_pub_t* npp);
    static void ui_nap_user_joined(nap_pub_t* npp, nap_cu_t* cu);
    static void ui_nap_user_parted(nap_pub_t* npp, nap_cu_t* cu);   
    static void ui_nap_update_counter(QLabel *label, int counter);
    static void ui_nap_channel_joined(nap_pub_t* npp);
    static void ui_nap_cp_update_op(nap_pub_t* npp);
};

#endif
