/* Copyright (C) 2007 The Lopster Team
   This is free software distributed under the terms of the
   GNU Public License.  See the file COPYING for details. */

#ifndef _UI_NAP_HOTLIST_H_
#define _UI_NAP_HOTLIST_H_

#include <QtGui>
#include "lcore/buddy.h"
#include "lcore/attribute.h"
#include "lcore/preferences.h"
#include "lcore/xml_handler.h"
#include "lcore/l_i18n.h"
#include "lcore/legacy.h"
#include "nap.h"
#include "nap_hotlist.h"
#include "nap_chat.h"
#include "nap_whois.h"
#include "nap_browse.h"

#include "lcore/qt4_ui/ui_buddies.hpp"


class NapUserEditorWidget : public BasicUserEditorWidget
{
public:
    NapUserEditorWidget(QWidget *parent=0);
    void ui_buddy_user_populate(buddy_t *buddy);
    void ui_buddy_user_apply(buddy_t *buddy);
};

class NapUserFuncs : public BuddyFuncs
{
public:
    void ui_buddy_plugin_user_update(user_t* user, UserItem *item);
    AbstractUserEditorWidget *ui_buddy_plugin_edit_user();
};

class NapHostlistActions : public QMenu
{
    Q_OBJECT   
public:
    NapHostlistActions(nap_user_t* user);
    void ui_create_chat_popup( );
    void ui_create_whois_popup( );
    void ui_create_browse_popup( );
    QMenu *ui_return_user_menu( ) {return main_popup;}
private slots:
    void on_buddy_browse(QAction *action);
    void on_buddy_whois(QAction *action);
    void on_buddy_chat(QAction *action);
private:
    QMenu* main_popup;
    nap_user_t* user;
    QHash <QAction *, nap_net_t*> net_actions;
};


class UiNapHotlist : public QObject
{
    Q_OBJECT
 public:
    static void ui_nap_hotlist_init();
    static void ui_nap_hotlist_cleanup();
};

#endif
