/* Copyright (C) 2007 The Lospter Team. This is free software
 * distributed under the terms of the GNU Public License.  See the
 * file COPYING for details.
 */
/* $Revision: 1.2 $
 * $Date: 2007/10/11 12:01:59 $
 * $Author: sid4u $
 */

#ifndef _UI_NAP_NET_H_
#define _UI_NAP_NET_H_

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include "lcore/l_http.h"
#include "nap_network.h"

#include "ui_nap.hpp"
#include "widgets/NapNetContentWidget.h"


class NapNetworkTreeWidget;

class UiNapNetwork : public QWidget, private Ui::NapNetContentWidget
{
    Q_OBJECT
public:
    UiNapNetwork(QWidget *parent = 0);
    ~UiNapNetwork(); 
    static void ui_nap_net_cleanup();
	static void ui_nap_net_init();
	static void ui_nap_server_new(nap_server_t* server);
	static void ui_nap_net_new(nap_net_t* net);
	static void ui_nap_ng_new(nap_ng_t* ng);
	static void ui_nap_service_hide(url_t* serv);
	static void ui_nap_service_update(url_t* serv);
	static void ui_nap_service_show(url_t* serv);
	static void ui_nap_service_new(url_t* serv);
    static UiNapNetwork *GetNapNetwork();
private :
    void ui_nap_init_mode_popup();
private slots:
    void service_remove();
    void service_changed(const QString&);
    void server_refresh();
    void mode(QAction *);
private:
	NapNetworkTreeWidget *nap_tree;
    QMenu *nap_mode_popup;
};

#endif
