/* Copyright (C) 2004 sgop@users.sourceforge.net
   This is free software distributed under the terms of the
   GNU Public License.  See the file COPYING for details. 
*/

/* $Revision: 1.12 $
 * $Date: 2007/09/11 07:36:25 $
 * $Author: sid4u $
 */


#include "lcore/l_i18n.h"
#include "nap_network.h"
#include "nap.h"

#include "lcore/qt4_ui/ui_preferences.hpp"
#include "lcore/qt4_ui/ui_main.hpp"
#include "ui_nap_pref.hpp"



UiNapPref::UiNapPref(QWidget *parent)
        :QWidget(parent)
{
    setupUi(this);
}

UiNapPref::~UiNapPref( )
{
}

UiNapPref *UiNapPref::ui_nap_pref_create() {
    UiNapPref *nap_pref = new UiNapPref();
	nap_pref->setObjectName("UiNapPref");
    LineEditPrefUpdater *nap_login =    
                new LineEditPrefUpdater("/nap/username", nap_pref->line_nap_username);
    LineEditPrefUpdater *nap_pass =     
                new LineEditPrefUpdater("/nap/password", nap_pref->line_nap_passwd);
    SpinBoxPrefUpdater *nap_port =  
                new SpinBoxPrefUpdater("/nap/listen/port", nap_pref->spin_nap_dataport);

    SpinBoxPrefUpdater *min_chat =
                new SpinBoxPrefUpdater("/nap/chat/channels/min", nap_pref->spin_nap_min_chan);

    SpinBoxPrefUpdater *max_chat =  
                new SpinBoxPrefUpdater("/nap/chat/channels/max", nap_pref->spin_nap_max_chan);
    QList <DropButtonValue *> items;
    items.append(new DropButtonValue(0,qfu("%1").arg(NapUserModes(0)), (1<<0), nap_pref));
    items.append(new DropButtonValue(0,qfu("%1").arg(NapUserModes(1)), (1<<1), nap_pref));
    items.append(new DropButtonValue(0,qfu("%1").arg(NapUserModes(2)), (1<<2), nap_pref));
    items.append(new DropButtonValue(0,qfu("%1").arg(NapUserModes(3)), (1<<3), nap_pref));
    items.append(new DropButtonValue(0,qfu("%1").arg(NapUserModes(4)), (1<<4), nap_pref));
    items.append(new DropButtonValue(0,qfu("%1").arg(NapUserModes(5)), (1<<5), nap_pref));
    items.append(new DropButtonValue(0,qfu("%1").arg(NapUserModes(6)), (1<<6), nap_pref));
    items.append(new DropButtonValue(0,qfu("%1").arg(NapUserModes(7)), (1<<7), nap_pref));
    items.append(new DropButtonValue(0,qfu("%1").arg(NapUserModes(8)), (1<<8), nap_pref));
    items.append(new DropButtonValue(0,qfu("%1").arg(NapUserModes(9)), (1<<9), nap_pref));
    items.append(new DropButtonValue(0,qfu("%1").arg(NapUserModes(10)), (1<<10), nap_pref));
    items.append(new DropButtonValue(0,qfu("%1").arg(NapUserModes(11)), (1<<11), nap_pref));
    items.append(new DropButtonValue(0,qfu("%1").arg(NapUserModes(12)), (1<<12), nap_pref));
    items.append(new DropButtonValue(0,qfu("%1").arg(NapUserModes(13)), (1<<13), nap_pref));
    items.append(new DropButtonValue(0,"", 0, nap_pref, true));
    items.append(new DropButtonValue(1,qfu("%1").arg(qtr("Additional Opennap-ng modes")),0,nap_pref));
    items.append(new DropButtonValue(0,qfu("%1").arg(NapUserModes(21)), (1<<21), nap_pref));
    items.append(new DropButtonValue(7,qfu("%1").arg(qtr("Additional SlavaNap modes")),0,nap_pref));
    items.append(new DropButtonValue(0,qfu("%1").arg(NapUserModes(14)), (1<<14), nap_pref));
    items.append(new DropButtonValue(0,qfu("%1").arg(NapUserModes(15)), (1<<15), nap_pref));
    items.append(new DropButtonValue(0,qfu("%1").arg(NapUserModes(16)), (1<<16), nap_pref));
    items.append(new DropButtonValue(0,qfu("%1").arg(NapUserModes(17)), (1<<17), nap_pref));
    items.append(new DropButtonValue(0,qfu("%1").arg(NapUserModes(18)), (1<<18), nap_pref));
    items.append(new DropButtonValue(0,qfu("%1").arg(NapUserModes(19)), (1<<19), nap_pref));
    items.append(new DropButtonValue(0,qfu("%1").arg(NapUserModes(20)), (1<<20), nap_pref));
    DropButtonPrefUpdater *user_mode = new DropButtonPrefUpdater("/nap/usermode",
                                    nap_pref->push_nap_usermode, items);

    CharsetPrefUpdater *charset_up = new CharsetPrefUpdater("/nap/charset", 
                                                        nap_pref->widget_charset);
    PreferencesDialog::ui_preferences_apply_cancel_add(nap_login);
    PreferencesDialog::ui_preferences_apply_cancel_add(nap_pass);
    PreferencesDialog::ui_preferences_apply_cancel_add(nap_port);
    PreferencesDialog::ui_preferences_apply_cancel_add(min_chat);
    PreferencesDialog::ui_preferences_apply_cancel_add(max_chat);
    PreferencesDialog::ui_preferences_apply_cancel_add(user_mode);
    PreferencesDialog::ui_preferences_apply_cancel_add(charset_up);
    return nap_pref;
}

void UiNapPref::ui_nap_pref_init() {
    PreferencesDialog::ui_preferences_plugin_add_page(NAP_ID, "Napster",
            qtr("Settings for the opennap network plugin"), 
				(CreatePrefPageFunc) ui_nap_pref_create);
}
