/* Copyright (C) 2005 sgop@users.sourceforge.net This is free software
 * distributed under the terms of the GNU Public License.  See the
 * file COPYING for details.
 */
/* $Revision: 1.9 $
 * $Date: 2007/09/12 15:22:05 $
 * $Author: sid4u $
 */

#include <stdarg.h>

#include <QComboBox>

#include "lcore/l_i18n.h"
#include "lcore/lopster.h"
#include "nap_network.h"
#include "nap.h"

#include "lcore/qt4_ui/ui_main.hpp"
#include "lcore/qt4_ui/ui_utils.hpp"
#include "ui_nap_search.hpp"
#include "widgets/NapSearchParameterWidget.h"

UiNapSearchOption::UiNapSearchOption(QObject* parent)
    : SearchOption(parent)
{
    widget = new QWidget; 
    Ui::NapSearchParameterWidget nap_search_parameters;
    nap_search_parameters.setupUi(widget);
    min = nap_search_parameters.combo_min;
    max = nap_search_parameters.combo_max;
    for (int i = 0; i <= 10; i++) {
        min->insertItem(i,qfu("%1").arg(NapSpeedStrShort(i)));
        max->insertItem(i,qfu("%1").arg(NapSpeedStrShort(i)));    
    }
}

UiNapSearchOption::~UiNapSearchOption() 
{
//    delete widget;
}

int UiNapSearchOption::search_option_set_value(search_pattern_t* pattern)
{
    attr_container_t* ac;
    attribute_t* attr;

    if (!pattern) return 1;
    ac = ATTRC(pattern);
    attr = attr_find(ac, "pattern", "NapSpeed");
    if (attr) {
        min->setCurrentIndex(((int*)(attr->value))[0]);
        max->setCurrentIndex(((int*)(attr->value))[1]);
        return 1;
    } else {
        min->setCurrentIndex(0);
        max->setCurrentIndex(0);
        return 0;
    }
}

int UiNapSearchOption::search_option_get_value(search_pattern_t* pattern)
{
  int imin, imax;
  
  if (!pattern) return 1; 
  

  imin = min->currentIndex();
  imax = max->currentIndex();

  if (imin < 0) imin = 0;
  if (imax < 0) imax = 0;

  if (imin || imax) {
    attr_store(ATTRC(pattern), "pattern", "NapSpeed", imin, imax);
    return 1;
  } else {
    return 0;
  }
}

void UiNapSearch::ui_nap_search_init() {
    UiNapSearchOption *option = new UiNapSearchOption();
    SearchPage::s_ui_search_register_option(option, NAP_ID);
}

void UiNapSearch::ui_nap_search_cleanup() {
}
