/* Copyright (C) 2007 The Lopster Team This is free software
 * distributed under the terms of the GNU Public License.  See the
 * file COPYING for details.
 */
/* $Revision: 1.1 $
 * $Date: 2007/09/11 07:35:16 $
 * $Author: sid4u $
 */

#ifndef _UI_NAP_WHOIS_H_
#define _UI_NAP_WHOIS_H_

#include <QList>
#include "nap_whois.h"
#include "nap_browse.h"
#include "nap_chat.h"
#include "nap_network.h"

#include "widgets/NapWhoisUserDialog.h"

class UiNapWhois : public QDialog, private Ui::NapWhoisUserDialog
{
    Q_OBJECT
public:
    UiNapWhois(QWidget *parent=0);
    void Update(nap_user_t* user);
    nap_user_t* ui_nap_whois_get_user() {return m_user;}
    static void ui_nap_whois_show(nap_user_t* user);
    static UiNapWhois *ui_nap_whois_search(nap_user_t* user);
private:
    QMenu *ui_nap_whois_actions();
private slots:
    void on_whois_close();
    void on_refresh();
    void on_chat();
    void on_browse();
private:
    nap_user_t* m_user;
    QAction *browse;
    QAction *chat;
    QAction *refresh;
};

#endif
