/* Copyright (C) 2005 sgop@users.sourceforge.net
   This is free software distributed under the terms of the
   GNU Public License.  See the file COPYING for details. */

#include <stdarg.h>

#include <gtk/gtk.h>

#include "lcore/utils.h"
#include "lcore/gtk2_ui/ui_layout.h"
#include "lcore/gtk2_ui/ui_main.h"
#include "lcore/gtk2_ui/ui_support.h"
#include "ui_slsk_net.h"
#include "ui_slsk_chat.h"
#include "ui_slsk_hotlist.h"
#include "ui_slsk_pref.h"
#include "slsk.h"
#include "slsk_users.h"

static GdkPixbuf* user_away = NULL;
static GdkPixbuf* user_online = NULL;
static GdkPixbuf* user_offline = NULL;

GdkPixbuf* ui_slsk_get_status_pixmap(slsk_user_t* user) {
  switch (user->status) {
  case SLSK_USER_ONLINE: return user_online;
  case SLSK_USER_OFFLINE: return user_offline;
  case SLSK_USER_AWAY: return user_away;
  default: return user_offline;
  }
}

void ui_slsk_init() {

  user_away = create_pixbuf("slsk_away.gif");
  user_online = create_pixbuf("slsk_online.gif");
  user_offline = create_pixbuf("slsk_offline.gif");

  ui_layout_register_paned("slsk:net:paned:pos");
  ui_layout_register_col("slsk:net:col:reco");
  ui_layout_register_col("slsk:net:col:rating");
  ui_layout_register_col("slsk:net:col:similar");
  ui_layout_register_col("slsk:net:col:urating");
  ui_layout_register_col("slsk:net:col:channel");
  ui_layout_register_col("slsk:net:col:users");

  ui_layout_register_paned("slsk:chat:paned:pos");
  ui_layout_register_col("slsk:chat:col:user");
  ui_layout_register_col("slsk:chat:col:shared");
  ui_layout_register_col("slsk:chat:col:speed");

  ui_layout_register_spin("slsk:chat:ticker:delay");
  ui_layout_register_spin("slsk:chat:ticker:move");
  ui_layout_register_vis("slsk:chat:ticker:vis");
  ui_layout_register_vis("slsk:net:channels:vis");
  
}

void ui_slsk_run() {
  ui_slsk_net_init();
  ui_slsk_chat_init();
  //  ui_slsk_search_init();
  ui_slsk_hotlist_init();
  ui_slsk_pref_init();
}

void ui_slsk_exit() {

}

#ifdef WIN32
#define _UI_SLSK_C_
#include "gtk2slskaliasdef.c"
#endif

