/* Copyright (C) 2005-2007 sgop@users.sourceforge.net
 * This is free software distributed under the terms of the
 * GNU Public License.  See the file COPYING for details.
 */
/* $Revision: 1.1 $
 * $Date: 2007/04/29 09:54:21 $
 * $Author: sgop $
 */

#include <gtk/gtk.h>

#include "lcore/gtk2_ui/ui_preferences.h"
#include "lcore/gtk2_ui/ui_support.h"
#include "lcore/utils.h"
#include "lcore/l_i18n.h"
#include "ui_slsk_pref.h"
#include "slsk.h"

static GtkWidget* ui_general_net(gboolean* expand)
{
    GtkWidget* vbox;
    GtkWidget* hbox;
    GtkWidget* table;
    GtkWidget* item;
    
    vbox = ui_create_section
        (_("Connection"), 
         _("Set the server address and port. Lopster needs to be restarted "
           "currently to take that into effect."),
         &hbox, NULL);
    
    table = gtk_table_new(1, 2, FALSE);
    gtk_box_pack_start(GTK_BOX(hbox), table, TRUE, TRUE, 0);
    gtk_table_set_col_spacings(GTK_TABLE(table), 5);
    
    item = ui_create_headed_item
        (_("server address (needs restart)"),
         ui_pref_string_entry("/slsk/server/address", NULL));
    gtk_table_attach(GTK_TABLE(table), item, 0, 1, 0, 1,
                     GTK_FILL|GTK_EXPAND,GTK_FILL|GTK_EXPAND,0,0);
    
    item = ui_create_headed_item
        (_("server port"), ui_pref_int_spin("/slsk/server/port", 1, 65535));
    gtk_table_attach(GTK_TABLE(table), item, 1, 2, 0, 1,
                     GTK_FILL,GTK_FILL,0,0);
    
    gtk_widget_show_all(vbox);
    
    if (expand) *expand = FALSE;
    return vbox;
}

static GtkWidget* ui_general_user(gboolean* expand)
{
    GtkWidget* vbox;
    GtkWidget* hbox;
    GtkWidget* table;
    GtkWidget* item;
    
    vbox = ui_create_section
        (_("User settings"),
         _("If you leave the user or password empty then the global default setting is used. The dataport specifies the port the soulseek module will accept connections. This port must lie in the allowed ports range from the core. If you don't like to accept connections you have to deactivate it in the core settings."),
         &hbox, NULL);

    table = gtk_table_new(1, 3, FALSE);
    gtk_box_pack_start(GTK_BOX(hbox), table, TRUE, TRUE, 0);
    gtk_table_set_col_spacings(GTK_TABLE(table), 5);
    
    item = ui_create_headed_item
        (_("username"), ui_pref_string_entry("/slsk/username", _("using default username")));
    gtk_table_attach(GTK_TABLE(table), item, 0, 1, 0, 1,
                     GTK_FILL|GTK_EXPAND,GTK_FILL|GTK_EXPAND,0,0);
    
    item = ui_create_headed_item
        (_("password"), ui_pref_string_entry("/slsk/password", _("using default password")));
    gtk_table_attach(GTK_TABLE(table), item, 1, 2, 0, 1,
                     GTK_FILL|GTK_EXPAND,GTK_FILL|GTK_EXPAND,0,0);
    
    item = ui_create_headed_item
        (_("data port"), ui_pref_int_spin("/slsk/listen/port", 1, 65535));
    gtk_table_attach(GTK_TABLE(table), item, 2, 3, 0, 1,
                     GTK_FILL,GTK_FILL,0,0);

    gtk_widget_show_all(vbox);
    
    if (expand) *expand = FALSE;
    return vbox;
}

/* static GtkWidget* ui_general_charset(gboolean* expand) { */
/*   GtkWidget* vbox; */
/*   GtkWidget* hbox; */
/*   GtkWidget* table; */
/*   GtkWidget* item; */
  
/*   vbox = ui_create_section */
/*     (_("Default character set"), */
/*      _("Lopster needs to know how to convert messages from other" */
/*        "users into the local format.\n\n" */
/*        "If unsure or if lopster warns you, try 'ISO-8859-1'."), */
/*      &hbox, NULL); */

/*   table = gtk_table_new(1, 1, FALSE); */
/*   gtk_box_pack_start(GTK_BOX(hbox), table, TRUE, TRUE, 0); */
/*   gtk_table_set_col_spacings(GTK_TABLE(table), 5); */

/*   item = ui_create_headed_item */
/*     (_("Character encoding"), ui_pref_charset_combo("/slsk/charset")); */
/*   gtk_table_attach(GTK_TABLE(table), item, 0, 1, 0, 1, */
/*                    GTK_FILL|GTK_EXPAND,GTK_FILL|GTK_EXPAND,0,0); */

/*   gtk_widget_show_all(vbox); */

/*   if (expand) *expand = FALSE; */
/*   return vbox; */
/* } */


void ui_slsk_pref_init()
{
    ui_pref_hook_plugin
        (SLSK_ID, ui_pref_register_leaf
         (    "SoulSeek", FALSE, "Settings for the SoulSeek network plugin",
              ui_general_user,
              ui_general_net,
/*           ui_general_charset, */
              NULL)
        );
    
    // mark string lists as handled.
    ui_pref_set_funcs("slsk:til", NULL, NULL, NULL);
    ui_pref_set_funcs("slsk:tih", NULL, NULL, NULL);
    // hide charset setting from the user...
    ui_pref_set_funcs("/slsk/charset", NULL, NULL, NULL);
}
