/* Copyright (C) 2005-2007 The Lopster Team
 * This is free software distributed under the terms of the
 * GNU Public License.  See the file COPYING for details.
 */
/* $Revision: 1.7 $
 * $Date: 2007/11/20 08:23:19 $
 * $Author: sid4u $
 */

#include "lcore/qt4_ui/ui_main.hpp"

#include "ui_slsk_net.hpp"
#include "ui_slsk_pref.hpp"
#include "ui_slsk.hpp"

QIcon ui_slsk_get_status_pixmap(slsk_user_t* user)
{
    
    switch (user->status) {
        case SLSK_USER_ONLINE: return QIcon(":/slsk_online.gif");
        case SLSK_USER_OFFLINE: return QIcon(":/slsk_offline.gif");
        case SLSK_USER_AWAY: return QIcon(":/slsk_away.gif");
        default: return QIcon(":/slsk_offline.gif");
    }
}

extern "C" QT4_SLSK_EXPORT void ui_slsk_init(ui_slsk_t* iface)
{
}

extern "C" QT4_SLSK_EXPORT void ui_slsk_run()
{
    UiSlSkNet::ui_slsk_net_init();
    UiSlskPref::ui_slsk_pref_init();
}

extern "C" QT4_SLSK_EXPORT void ui_slsk_exit()
{
    UiSlSkNet::ui_slsk_net_cleanup();
}

extern "C" QT4_SLSK_EXPORT void ui_slsk_whois_new(slsk_user_t* user){}
extern "C" QT4_SLSK_EXPORT void ui_slsk_whois_pic_progress(slsk_user_t* user, char* buffer,
				guint32 progress, guint32 max){}
extern "C" QT4_SLSK_EXPORT void ui_slsk_whois_finish(slsk_user_t* user){}
extern "C" QT4_SLSK_EXPORT void ui_slsk_reco_clear()
{
    UiSlSkNet::ui_slsk_reco_clear();
}

extern "C" QT4_SLSK_EXPORT void ui_slsk_reco_add(const char* item, int rating)
{
    UiSlSkNet::ui_slsk_reco_add(item,rating);
}

extern "C" QT4_SLSK_EXPORT void ui_slsk_reco_user_clear()
{
    UiSlSkNet::ui_slsk_reco_user_clear();
}

extern "C" QT4_SLSK_EXPORT void ui_slsk_reco_user_add(slsk_user_t* user, int rating)
{
    UiSlSkNet::ui_slsk_reco_user_add(user,rating);
}

extern "C" QT4_SLSK_EXPORT void ui_slsk_net_show(slsk_net_t* net)
{
    UiSlSkNet::ui_slsk_net_show(net);
}

extern "C" QT4_SLSK_EXPORT void ui_slsk_show_channels(slsk_net_t* net)
{
    UiSlSkNet::ui_slsk_show_channels(net);
}

extern "C" QT4_SLSK_EXPORT void ui_slsk_create_public_page(slsk_cp_t* page){}
extern "C" QT4_SLSK_EXPORT void ui_slsk_create_private_page(slsk_cp_t* scp){}
extern "C" QT4_SLSK_EXPORT void ui_slsk_channel_joined(slsk_cp_t* scp){}
extern "C" QT4_SLSK_EXPORT void ui_slsk_ticker_show(slsk_cp_t* scp, slsk_ct_t* ticker){}
extern "C" QT4_SLSK_EXPORT void ui_slsk_user_show(slsk_cp_t* scp, slsk_user_t* user){}
extern "C" QT4_SLSK_EXPORT void ui_slsk_user_joined(slsk_cp_t* scp, slsk_user_t* user){}
extern "C" QT4_SLSK_EXPORT void ui_slsk_user_parted(slsk_cp_t* scp, slsk_user_t* user){}

QIcon ui_slsk_get_res_icon(const QString &res, const QSize &size, bool grey)
{
    QIcon orig;
    QIcon result;
    orig = QIcon(res);
    if (orig.isNull())
    {
        return orig;
    }
    
    QIcon::Mode mode = grey? (QIcon::Disabled) : (QIcon::Normal) ;
    result =  QIcon( orig ).pixmap(size, mode);
    return result;
}

