/* Copyright (C) 2005 Lopster Team
   This is free software distributed under the terms of the
   GNU Public License.  See the file COPYING for details. */

#ifndef _UI_SLSK_HPP_
#define _UI_SLSK_HPP_

#include <qglobal.h>
#include "slsk.h"
#include "slsk_ui.h"
#include "slsk_users.h"

inline void initSoulseekResource() {Q_INIT_RESOURCE( soulseek ); }

#define SICON(a,b) ui_slsk_get_res_icon(a,b)
#define SICONG(a,b) ui_slsk_get_res_icon(a,b,true)

#ifdef _BUILD_QT4_SLSK_LIB_
    #if defined(QT_DLL) || defined(QT_SHARED)
        #define QT4_SLSK_EXPORT Q_DECL_EXPORT
    #endif
#else
        #define QT4_SLSK_EXPORT Q_DECL_IMPORT
#endif 

QIcon ui_slsk_get_status_pixmap(slsk_user_t* user);
QIcon ui_slsk_get_res_icon(const QString &res, const QSize &size, bool grey=false);

extern "C" QT4_SLSK_EXPORT void ui_slsk_init(ui_slsk_t* iface);
extern "C" QT4_SLSK_EXPORT void ui_slsk_run();
extern "C" QT4_SLSK_EXPORT void ui_slsk_exit();

extern "C" QT4_SLSK_EXPORT void ui_slsk_whois_new(slsk_user_t* user);
extern "C" QT4_SLSK_EXPORT void ui_slsk_whois_pic_progress(slsk_user_t* user, char* buffer,
				guint32 progress, guint32 max);
extern "C" QT4_SLSK_EXPORT void ui_slsk_whois_finish(slsk_user_t* user);
extern "C" QT4_SLSK_EXPORT void ui_slsk_reco_clear();
extern "C" QT4_SLSK_EXPORT void ui_slsk_reco_add(const char* item, int rating);
extern "C" QT4_SLSK_EXPORT void ui_slsk_reco_user_clear();
extern "C" QT4_SLSK_EXPORT void ui_slsk_reco_user_add(slsk_user_t* user, int rating);
extern "C" QT4_SLSK_EXPORT void ui_slsk_net_show(slsk_net_t* net);
extern "C" QT4_SLSK_EXPORT void ui_slsk_show_channels(slsk_net_t* net);
extern "C" QT4_SLSK_EXPORT void ui_slsk_create_public_page(slsk_cp_t* page);
extern "C" QT4_SLSK_EXPORT void ui_slsk_create_private_page(slsk_cp_t* scp);
extern "C" QT4_SLSK_EXPORT void ui_slsk_channel_joined(slsk_cp_t* scp);
extern "C" QT4_SLSK_EXPORT void ui_slsk_ticker_show(slsk_cp_t* scp, slsk_ct_t* ticker);
extern "C" QT4_SLSK_EXPORT void ui_slsk_user_show(slsk_cp_t* scp, slsk_user_t* user);
extern "C" QT4_SLSK_EXPORT void ui_slsk_user_joined(slsk_cp_t* scp, slsk_user_t* user);
extern "C" QT4_SLSK_EXPORT void ui_slsk_user_parted(slsk_cp_t* scp, slsk_user_t* user);


#endif
