/* Copyright (C) 2007   The Lopster Team
   This is free software distributed under the terms of the
   GNU Public License.  See the file COPYING for details. */

#ifndef _UI_SLSK_NET_HPP_
#define _UI_SLSK_NET_HPP_

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include "slsk_network.h"
#include "slsk_chat.h"
#include "slsk_til.h"
#include "slsk.h"

#include "widgets/SlNetworkWidget.h"

class SimilarUserModel;
class RecommendationModel;
class ChannelModel;

class UiSlSkNet : public QWidget, private Ui::SlNetworkWidget
{
public:
    UiSlSkNet(QWidget *parent=0);

    static UiSlSkNet *GetSlSkNet();
    
    static void ui_slsk_net_init();
    static void ui_slsk_net_cleanup();

    static void ui_slsk_show_channels(slsk_net_t* net);

    static void ui_slsk_reco_user_add(slsk_user_t* user, int rating);
    static void ui_slsk_reco_user_update(slsk_user_t* user);
    static void ui_slsk_reco_user_clear();

    static void ui_slsk_reco_add(const char* item, int rating);
    static void ui_slsk_reco_clear();

    static void ui_slsk_net_update(slsk_net_t* net);
    static void ui_slsk_net_show(slsk_net_t* net);

//    static void ui_slsk_net_show(slsk_net_t* net);
private:
    slsk_net_t* m_net;
    SimilarUserModel *model_similar;
    RecommendationModel *model_reco;
    ChannelModel *model_channel;
};

#endif
