/* Copyright (C) 2007 The Lopster team
   This is free software distributed under the terms of the
   GNU Public License.  See the file COPYING for details. */


/* $Revision: 1.1 $
 * $Date: 2007/11/20 08:23:19 $
 * $Author: sid4u $
 */


#include "lcore/l_i18n.h"
#include "slsk_network.h"
#include "slsk.h"

#include "lcore/qt4_ui/ui_preferences.hpp"
#include "lcore/qt4_ui/ui_main.hpp"
#include "ui_slsk_pref.hpp"



UiSlskPref::UiSlskPref(QWidget *parent)
        :QWidget(parent)
{
    setupUi(this);
}

UiSlskPref::~UiSlskPref( )
{
}

UiSlskPref *UiSlskPref::ui_slsk_pref_create() {
    UiSlskPref *slsk_pref = new UiSlskPref();
	slsk_pref->setObjectName("UiSlskPref");

    LineEditPrefUpdater *slsk_login =    
                new LineEditPrefUpdater("/slsk/username", slsk_pref->line_username);
    LineEditPrefUpdater *slsk_pass =     
                new LineEditPrefUpdater("/slsk/password", slsk_pref->line_password);
    SpinBoxPrefUpdater *slsk_data =  
                new SpinBoxPrefUpdater("/slsk/listen/port", slsk_pref->spin_data);

    LineEditPrefUpdater *slsk_server =  
                new LineEditPrefUpdater("/slsk/server/address", slsk_pref->line_server);
    SpinBoxPrefUpdater *slsk_port =  
                new SpinBoxPrefUpdater("/slsk/server/port", slsk_pref->spin_port);
    

    PreferencesDialog::ui_preferences_apply_cancel_add(slsk_login);
    PreferencesDialog::ui_preferences_apply_cancel_add(slsk_pass);
    PreferencesDialog::ui_preferences_apply_cancel_add(slsk_data);
    PreferencesDialog::ui_preferences_apply_cancel_add(slsk_server);
    PreferencesDialog::ui_preferences_apply_cancel_add(slsk_port);

    return slsk_pref;
}

void UiSlskPref::ui_slsk_pref_init() {
    PreferencesDialog::ui_preferences_plugin_add_page(SLSK_ID, "Soulseek",
            qtr("Settings for the soulseek network plugin"), 
				(CreatePrefPageFunc) ui_slsk_pref_create);
}
