/* Copyright (C) 2005 sgop@users.sourceforge.net
 * This is free software distributed under the terms of the
 * GNU Public License.  See the file COPYING for details.
 */
/* $Revision: 1.2 $
 * $Date: 2007/05/23 20:42:29 $
 * $Author: sid4u $
 */

#ifndef _SLSK_CHAT_H_
#define _SLSK_CHAT_H_

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include "lcore/chat.h"
#include "lcore/module.h"
#include "slsk_network.h"
#include "slsk_users.h"

G_BEGIN_DECLS

#define SLSK_PAGE_OTHER    0
#define SLSK_PAGE_PUBLIC   1
#define SLSK_PAGE_PRIVATE  2


typedef struct {
  chat_page_t _page;
  slsk_net_t* net;
  int type;
  gboolean leaving;
  GList* users;
  GList* ticker;

  char* charset;
  gboolean charset_warned;
} slsk_cp_t;
#define SCP(arg) ((slsk_cp_t*)(arg))

typedef struct {
  object_t _object;
  char* message;
  char* orig_message;
} slsk_ct_t;

module_t* slsk_chat_module_instance();

slsk_cp_t* slsk_cp_search_net(slsk_net_t* net, const char* channel, int type);
slsk_cp_t* slsk_cp_search(const char* channel, int type);
slsk_cp_t* slsk_cp_new_private(slsk_net_t* net, const char* nick);
void slsk_cp_set_encoding(slsk_cp_t* page, const char* charset);

void slsk_public_message(slsk_net_t* net, char* channel, char* user, char* message);
void slsk_private_message(slsk_net_t* net, char* nick, char* message, int timestamp);
void slsk_emote_message(slsk_net_t* net, char* channel, char* user, char* message);
void slsk_global_message(slsk_net_t* net, char* message);

void slsk_user_joined(slsk_cp_t* scp, slsk_user_t* user, gboolean show);
void slsk_user_parted(slsk_cp_t* scp, const char* user);

void slsk_send_private_message(slsk_net_t* net, char* nick, char *message);
void slsk_send_public_message(slsk_cp_t* scp, char* message);

void slsk_channel_parted(slsk_cp_t* scp);
void slsk_channel_joined(slsk_cp_t* scp);

void slsk_ticker_new(slsk_cp_t* scp, const char* nick, const char* message);
void slsk_ticker_remove(slsk_cp_t* scp, const char* user);
void slsk_set_ticker(slsk_cp_t* scp, const char* message);

G_END_DECLS
#endif
