/* Copyright (C) 2005 sgop@users.sourceforge.net
 * This is free software distributed under the terms of the
 * GNU Public License.  See the file COPYING for details.
 */
/* $Revision: 1.1 $
 * $Date: 2007/04/29 09:55:05 $
 * $Author: sgop $
 */

#ifndef _SLSK_CON_H_
#define _SLSK_CON_H_

#define VAL_NONE      0
#define VAL_INC       1
#define VAL_STRING    2
#define VAL_INT       3
#define VAL_DINT      4
#define VAL_BYTE      5
#define VAL_IP        6
#define VAL_BIN       7

#include "lcore/tcp_socket.h"
#include "lcore/files.h"

#define REQ_LEN(len) \
  if (dlen<(len)) {g_log("SLSK_CON", G_LOG_LEVEL_WARNING, l_printf("needed %u bytes", len)); return;}
#define CHECK_LEN(len) \
  if (dlen!=(len)) {g_log("SLSK_CON", G_LOG_LEVEL_WARNING, "expected %u bytes, not %u", len, dlen); print_raw(NULL, data, dlen); }
#define CHECK(expr) \
  if (!(expr)) {g_log("SLSK_CON", G_LOG_LEVEL_WARNING, "invalid message at %s:%d", __FILE__, __LINE__); return;}


typedef struct {
  guint32 type;
  guint32 length;
  char* data;
} slsk_message_t;

#define SLSK_CON(arg) ((slsk_con_t*)(arg))
typedef struct {
  tcp_socket_t _tsock;
  char type;
} slsk_con_t;

void slsk_con_destroy(slsk_con_t* con);
void slsk_con_init(slsk_con_t* con, const char* name, char type, int timeout);
void slsk_message(slsk_message_t* message, char dir, slsk_con_t* con, int level, ...);

slsk_message_t* slsk_consume_message(buffer_t* buffer);
int slsk_pack_file(char* buffer, file_t* file, gboolean winname);
file_t* slsk_unpack_file(char** data, unsigned* dlen);



#endif

