/* Copyright (C) 2005 sgop@users.sourceforge.net
 * This is free software distributed under the terms of the
 * GNU Public License.  See the file COPYING for details.
 */
/* $Revision: 1.2 $
 * $Date: 2007/05/23 20:42:29 $
 * $Author: sid4u $
 */

#ifndef _SLSK_NET_H_
#define _SLSK_NET_H_

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include "lcore/module.h"
#include "slsk_con.h"

G_BEGIN_DECLS

#define SLSK_NET_OFFLINE    0
#define SLSK_NET_CONNECTING 1
#define SLSK_NET_ONLINE     2

typedef struct {
  slsk_con_t _con;
  char* address;
  char* nick;
  char* pass;
  unsigned long ip;
  unsigned short port;
  int status;
  char* status_message;
  int privileges;
  GList* channels;
} slsk_net_t;

#define SLSK_NET(n) ((slsk_net_t*)(n))

typedef struct {
  char* name;
  int online;
  slsk_net_t* net;
} slsk_channel_t;

module_t* slsk_net_module_instance();

/* void slsk_net_get_list(const char* url); */

void slsk_net_connect(slsk_net_t* net);
void slsk_net_disconnect(slsk_net_t* net);
void slsk_net_set_privileges(slsk_net_t* net, int priv);

void slsk_join_channel(slsk_net_t* net, const char* name);

void slsk_net_send(slsk_net_t* net, guint32 type, ...);
void slsk_net_update_shares(slsk_net_t* net);
void slsk_net_channel_add(slsk_net_t* net, slsk_channel_t* channel, gboolean update);
void slsk_net_success(slsk_net_t* net, char* message);
void slsk_net_channel_remove(slsk_net_t* net, const char* channel);
void slsk_net_channels_clear(slsk_net_t* net);

slsk_net_t* slsk_net_get_online();
void slsk_net_check_privileges(slsk_net_t* net);

void slsk_connect_change(unsigned status);

const char* slsk_net_get_username(slsk_net_t* net);

G_END_DECLS
#endif
