/* Copyright (C) 2005 sgop@users.sourceforge.net
 * This is free software distributed under the terms of the
 * GNU Public License.  See the file COPYING for details.
 */
/* $Revision: 1.1 $
 * $Date: 2007/04/29 09:55:06 $
 * $Author: sgop $
 */

#ifndef _SLSK_PROTO_H_
#define _SLSK_PROTO_H_

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include "lcore/tcp_socket.h"
#include "slsk_network.h"
#include "slsk_con.h"

#define SLSK_S_LOGIN                 1
#define SLSK_S_SET_LISTEN            2
#define SLSK_S_GET_ADDRESS           3
#define SLSK_S_ADD_USER              5
#define SLSK_S_REMOVE_USER           6
#define SLSK_S_GET_STATUS            7
#define SLSK_S_PUBLIC               13
#define SLSK_S_JOIN_CHANNEL         14
#define SLSK_S_PART_CHANNEL         15
#define SLSK_S_REQUEST_PEER         18
#define SLSK_S_PRIVMSG              22
#define SLSK_S_PRIVMSG_ACK          23
#define SLSK_S_SEARCH               26
#define SLSK_S_SET_STATUS           28
#define SLSK_S_PING                 32
#define SLSK_S_SHARE_LIB            35
#define SLSK_S_ADD_LIKE             51
#define SLSK_S_REMOVE_LIKE          52
#define SLSK_S_LOCAL_RECO           54
#define SLSK_S_GLOBAL_RECO          56
#define SLSK_S_USER_RECO            57
#define SLSK_S_HAVE_NO_PARENT       71
#define SLSK_S_CHECK_PRIVILEGES     92
#define SLSK_S_SIMILAR_USERS       110
#define SLSK_S_ITEM_RECO           111
#define SLSK_S_ITEM_USERS          112
#define SLSK_S_SET_TICKER          116
#define SLSK_S_ADD_HATE            117
#define SLSK_S_REMOVE_HATE         118
#define SLSK_S_CANT_CONNECT       1001


/*
SendSpeed:34,
                   GetUserStats:36,QueuedDownloads:40,Relogged:41,
                   PlaceInLineResponse:60,RoomAdded:62,RoomRemoved:63,
                   RoomList:64,ExactFileSearch:65,AdminMessage:66, 
                   GlobalUserList:67,TunneledMessage:68,PrivilegedUsers:69,
                   Msg83:83,Msg84:84,Msg85:85,ParentInactivityTimeout:86,
                   SearchInactivityTimeout:87,MinParentsInCache:88,
                   Msg89:89,DistribAliveInterval:90,
                   AddToPrivileged:91,
                   SearchRequest:93,NetInfo:102,
                   WishlistSearch:103,WishlistInterval:104}
*/



const char* slsk_handle_message(slsk_net_t* net, slsk_message_t* command);
void slsk_pack_command(slsk_net_t* net, guint32 type, va_list ap);

#endif
