/* Copyright (C) 2005 sgop@users.sourceforge.net
   This is free software distributed under the terms of the
   GNU Public License.  See the file COPYING for details. */

#ifndef _SLSK_UI_H_
#define _SLSK_UI_H_

#include "slsk_chat.h"
#include "slsk_network.h"
#include "slsk_whois.h"
#include "slsk_users.h"

typedef struct {

  void (*create_public_page)(slsk_cp_t*);
  void (*create_private_page)(slsk_cp_t*);
  void (*channel_joined)(slsk_cp_t*);
  void (*user_show)(slsk_cp_t*, slsk_user_t*);
  void (*user_joined)(slsk_cp_t*, slsk_user_t*);
  void (*user_parted)(slsk_cp_t*, slsk_user_t*);

  void (*ticker_show)(slsk_cp_t* page, slsk_ct_t* ticker);

  void (*whois_new)(slsk_user_t*);
  void (*whois_pic_progress)(slsk_user_t*, char*, guint32, guint32);
  void (*whois_finish)(slsk_user_t*);

  void (*net_show)(slsk_net_t*);

  void (*update_channels)(slsk_net_t*);

  void (*reco_clear)(void);
  void (*reco_add)(const char*, int);
  void (*reco_user_clear)(void);
  void (*reco_user_add)(slsk_user_t*, int);

} ui_slsk_t;

extern ui_slsk_t SLSKUI;

module_t* slsk_ui_module_instance();

#endif
