/* Copyright (C) 2005 sgop@users.sourceforge.net This is free software
 * distributed under the terms of the GNU Public License.  See the
 * file COPYING for details.
 */
/* $Revision: 1.3 $
 * $Date: 2007/11/16 11:49:27 $
 * $Author: sid4u $
 */

#ifndef _SLSK_USERS_H_
#define _SLSK_USERS_H_

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include "lcore/user.h"
#include "lcore/utils.h"
#include "lcore/module.h"
#include "slsk_network.h"

G_BEGIN_DECLS

#define SLSK_PRIV_UNKNOWN     0
#define SLSK_PRIV_ON          1
#define SLSK_PRIV_OFF         2

#define SLSK_USER(arg) ((slsk_user_t*)(arg))
typedef struct {
  user_t _user;
  int mon_cnt;
  time_t refreshed;  // ip/port
  slsk_net_t* net;
  gboolean privileges;

  int status;

  int shared;
  int speed;
  int downloads;
  int shared_dirs;
  
  // from whois
  char* description;
  int all_slots;
  int queued;
  gboolean has_slots;

} slsk_user_t;

module_t* slsk_user_module_instance();


slsk_user_t* slsk_user_find(const char* nick);
int slsk_user_get_privileges(const char* nick);
int slsk_user_get_status(const char* nick);
gboolean slsk_user_online(slsk_user_t* user);
gboolean slsk_user_get_firewalled(slsk_user_t* user);
gboolean slsk_user_ip_known(slsk_user_t* user);

void slsk_user_set_firewalled(slsk_user_t* user, gboolean wall);
void slsk_user_set_privileges(slsk_user_t* user, int priv);
void slsk_user_set_ip_port(slsk_user_t* user, ip_t ip, port_t port);
void slsk_user_set_net(slsk_user_t* user, slsk_net_t* net);
void slsk_user_set_status(slsk_user_t* user, int status);
void slsk_user_set_info(slsk_user_t* user, int speed,
                        int down, int shared, int dirs);
void slsk_user_set_whois(slsk_user_t* user, int slots,
                         int queued, gboolean has_slots);

void slsk_user_set_know_privileges();

G_END_DECLS
#endif
