/* Copyright (C) 2005 sgop@users.sourceforge.net
   This is free software distributed under the terms of the
   GNU Public License.  See the file COPYING for details. */

#include "lcore/utils.h"
#include "slsk_whois.h"
#include "slsk_ui.h"

void slsk_whois_new(slsk_user_t* user) {
  SLSKUI.whois_new(user);
}

void slsk_whois_set_progress(slsk_user_t* user, 
			     char* buffer, unsigned avail) {
  guint32 len;

  if (avail < 4) return;
  // skip the nickname
  len = unpack_u32(&buffer, &avail);
  if (avail < len) return;
  buffer += len;
  avail -= len;

  // check whether there is an image.
  if (avail < 1) return;
  if (unpack_byte(&buffer, &avail)) {
    if (avail < 4) return;
    len = unpack_u32(&buffer, &avail);
    SLSKUI.whois_pic_progress(user, buffer, avail, len);
  }
  
}

void slsk_whois_finish(slsk_user_t* user) {
  SLSKUI.whois_finish(user);
}
